@ECHO OFF

ECHO **********************************************************************
ECHO * MAKEMULT.BAT fr F-TP 1.00  [ Turbo-FORTH-83 fr Transputer T800 ] *
ECHO *                                                                    *
ECHO *  Metacompilation eines Verbund-Systems mit mehreren Teilsystemen   *
ECHO *                                                                    *
ECHO *     Fred Behringer  Planegger Str. 24  81241 Mnchen   5.4.96      *
ECHO **********************************************************************


IF NOT EXIST TRANSMUL.COM GOTO Fehler1
IF NOT EXIST TRANSSYS.COM GOTO Fehler2
IF NOT EXIST TRANSMET.COM GOTO Fehler3
IF NOT EXIST  TKERNEL.FTH GOTO Fehler4
IF NOT EXIST    TCORE.FTH GOTO Fehler5
IF NOT EXIST  COMMAND.COM GOTO Fehler6
IF NOT EXIST ADDMULTI.FTH GOTO Fehler7


GOTO OK

:Fehler1
ECHO.
ECHO Datei TRANSMUL.COM nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\BIN\TRANSMUL.COM ) .
GOTO Ende

:Fehler2
ECHO.
ECHO Datei TRANSSYS.COM nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\BIN\TRANSSYS.COM ) .
GOTO Ende

:Fehler3
ECHO.
ECHO Datei TRANSMET.COM nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\BIN\TRANSMET.COM ) .
GOTO Ende

:Fehler4
ECHO.
ECHO Datei TKERNEL.FTH nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\SRC\TKERNEL.FTH ) .
GOTO Ende

:Fehler5
ECHO.
ECHO Datei TCORE.FTH nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\SRC\TCORE.FTH ) .
GOTO Ende

:Fehler6
ECHO.
ECHO Datei COMMAND.COM nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls das Wort SHELL im hier verwendeten F-TP
ECHO so umbauen, da COMMAND.COM mit Pfadangabe ( z.B.
ECHO C:\COMMAND.COM ) erscheint.
GOTO Ende

:Fehler7
ECHO.
ECHO Datei ADDMULTI.FTH nicht im (aktuellen) Verzeichnis !
ECHO Gegebenenfalls in MAKEMULT.BAT, der vorliegenden Datei,
ECHO Pfad einbauen ( z.B. E:\F-TP\SRC\MAKEMULTI.FTH ) .
GOTO Ende

:OK
TRANSMUL  MAIN SAVE-SYSTEM TRANSMUL.COM BYE

:Makeall
TRANSMUL  UPDATE SAVE-SYSTEM TRANSMUL.COM BYE

TRANSMUL  ORG 2@ 40 0FE L! 40 0FC L! BYE
TRANSMET   SERVER 40 0FC L@ 40 0FE L@ ORG 2! SAVE-SYSTEM TRANSMET.COM BYE
TRANSSYS   SERVER 40 0FC L@ 40 0FE L@ ORG 2! SAVE-SYSTEM TRANSSYS.COM BYE

TRANSMUL  EOS 2@ 40 0FE L! 40 0FC L! BYE
TRANSMET   SERVER 40 0FC L@ 40 0FE L@ EOS 2! SAVE-SYSTEM TRANSMET.COM BYE
TRANSSYS   SERVER 40 0FC L@ 40 0FE L@ EOS 2! SAVE-SYSTEM TRANSSYS.COM BYE

ECHO.
ECHO Jetzt wird TKERNEL.FTH fr Subsystem
TRANSMUL   COUNTER @ . BYE
ECHO.
ECHO von insgesamt
TRANSMUL   ANZAHL  @ . BYE
ECHO.
ECHO Subsystemen metacompiliert.
ECHO Danach wird fr dasselbe Subsystem TCORE.FTH per INCLUDE hinzucompiliert.
ECHO.
CHOICE /c:wa /N /t:w,5 Abbrechen: a . Sie haben dazu 5 sec Zeit. Weiter: w -
IF ERRORLEVEL 2 GOTO Exit

TRANSMET   SERVER TRESET TEST-IT ECHO OFF INCLUDE TKERNEL BYE
ECHO.
ECHO Metacompiliert wurde jetzt TKERNEL.FTH fr Subsystem
TRANSMUL   COUNTER @ . BYE
ECHO.
ECHO von insgesamt
TRANSMUL   ANZAHL  @ . BYE
ECHO.
ECHO Subsystemen.
ECHO Jetzt wird fr dasselbe Subsystem TCORE.FTH per INCLUDE hinzucompiliert.
ECHO.
CHOICE /c:wa /N /t:w,5 Abbrechen: a . Sie haben dazu 5 sec Zeit. Weiter: w -
IF ERRORLEVEL 2 GOTO Exit1
ECHO.
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ ECHO OFF INCLUDE TCORE BYE-FOR-DOS
TRANSMUL   COUNTER @ HEX 40 0FE L! BYE
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ HEX 40 0FE @-H SYS-ID ! BYE-FOR-DOS
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ ECHO OFF INCLUDE ADDMULTI BYE-FOR-DOS

TRANSMUL   COUNTER @ BYE
IF NOT ERRORLEVEL 2 GOTO Make1
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ EMPTY BYE-FOR-DOS

:Make1
TRANSMUL   RESTZAHL @ BYE
IF ERRORLEVEL 1 GOTO Makeall
GOTO Einsprung

:Exit
TRANSMUL   COUNTER @ BYE
IF NOT ERRORLEVEL 1 GOTO Nichts
GOTO Einsprung

:Exit1
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ ECHO OFF INCLUDE ADDMULTI BYE-FOR-DOS

TRANSMUL   COUNTER @ BYE
IF NOT ERRORLEVEL 1 GOTO Nichts

:Einsprung
ECHO.
ECHO Jetzt wird TRANSSYS.COM  auf den Workspace-Pointer  des ersten Subsystems
ECHO eingestellt  und ber den in TRANSSYS.COM enthaltenen Server in eben die-
ECHO ses Subsystem gesprungen. TRANSSYS.COM ist damit auch bereit, das Gesamt-
ECHO system ( das Multisystem ) ber LOAD-FTP M immer wieder neu einzuladen.
ECHO.
ECHO Multisystem abspeichern:  SAVE-MULTI TFORTH.FYM [RET]
ECHO Zu Subsystem n springen:  n GOSUB [RET]
ECHO Hol HERE von Subsystem n: n THERE [RET]
ECHO                           Fr Datenbergabe von Subsystem zu Subsystem
ECHO Exit zum Host:            [ESC] oder BYE [RET]
ECHO Vom Host wieder einladen: START [RET]
ECHO Exit direkt zu DOS:       F8 oder BYE-FOR-DOS [RET]
ECHO Dann wieder einladen:     TRESUME [RET]
ECHO Spter einladen:          LOAD-FTP MULTI (oder einfach LOAD-FTP M) [RET]
ECHO                           Bei LOAD-FTP M geht der Stackinhalt der Subsy-
ECHO                           steme verloren, bei TRESUME nicht.
ECHO.
PAUSE
TRANSMUL   SUBORG 4+ 2@ 40 0FE L! 40 0FC L! BYE
TRANSSYS   SERVER 40 0FC L@ 40 0FE L@ ORG 2! SAVE-SYSTEM TRANSSYS.COM BYE
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT^ INIT EMPTY BYE-FOR-DOS
TRANSSYS   SERVER TRESET GOTO-SYSTEM-BOOT

GOTO Ende

:Nichts
ECHO.
ECHO Metacompilierprozess misslungen. Kein Subsystem geladen.
ECHO.

:Ende
