\ **********************************************************
\ *                                                        *
\ *  TKERNEL.FTH                                           *
\ *                                                        *
\ *  Erster Teil  des Quelltextes  des 32-Bit-Transputer-  *
\ *  FORTH-Systems. Wird von TRANSMET.COM metacompiliert.  *
\ *                                                        *
\ *  Fred Behringer,   Planegger Str. 24,   81241 Mnchen  *
\ *  Version 1.00                -              27.5.1992  *
\ *                                                        *
\ **********************************************************

\ Wptr im Server als : WPTR ORG 2@ 100. D- ; definiert
\ Wenn das auf einen anderen Wert als 100. gendert wird, hier vermerken !

HEIGHT 2* ALLOC DROP \ Reserviert 64K als Host-Zwischenspeicher fr (PUT)
META IN-META SERVER ALSO
START-META
HEX
SERVER
WPTR 80 D+ DP-T 2!        \ WPTR wird vom Server vorgegeben. Es werden 20h
                          \ Zellen fr Systemvariablen reserviert. Bei n-
                          \ derung auch UP ( siehe unten ) ndern !
                          \ Bis jetzt ( 15.5.95 ) sind nur 15h Zellen vor-
                          \ gesehen. Der Rest kann frei verwendet werden.
META
IN-META ASSEMBLER

CR .( USER-Variablen einrichten und initialisieren )  \ frher weiter hinten
ALIGN-T
                          \ USER-Area einrichten
 0 ,        ( TOS      )
 0 ,        ( ENTRY    )
 0 ,        ( LINK     )
 0 ,        ( SP0      )  \ Wird gleich ( bei EOS ) belegt
 0 ,        ( RP0      )  \ Wird unten belegt
 0 ,        ( DP       )  \ Wird spter belegt
 0 ,        ( #OUT     )
 0 ,        ( #LINE    )
 0 ,        ( HANDLE   )
0A ,        ( BASE     )
 0 ,        ( HLD      )
 0 ,        ( PRINTING )
-1 ,        ( ECHO     )
 0 ,        ( EMIT     )  \ Wird spter belegt

SERVER ORG 2@             \ Um eine saubere Schnittstelle zu bekommen, werden
META  DP-T 2!             \ fr das Hauptsystem  ( "Grund-Task" )  20h Zellen
                          \ reserviert.  In Anlehnung  an Turbo-Forth ( F83 )
                          \ werden bis jetzt ( 15.5.95 ) fr die USER-VARIAB-
                          \ LEN  nur 0Eh Zellen bentigt.  Der Rest kann vor-
                          \ lufig frei verwendet werden.

LABEL ORIGIN
COLDP LDL GCALL  \ Sprung zu Kaltstart
WARMP LDL GCALL  \ Sprung zu Warmstart

LABEL CPUSH  AREG STL  SP LDL  -4 ADC  SP STL  SP LDL  0 STNL  0 LDC
LABEL BPUSH  AREG STL  SP LDL  -4 ADC  SP STL  SP LDL  0 STNL
LABEL >NEXT  IP LDL  0 LDNL  W STL  IP LDL  4 ADC  IP STL  W LDL  0 LDNL  GCALL

H: 1PUSH  META ASSEMBLER       BPUSHP LDL  GCALL ;
H: 2PUSH  META ASSEMBLER       CPUSHP LDL  GCALL ;
H: 3PUSH  META ASSEMBLER APUSH CPUSHP LDL  GCALL ;
H: NEXT   META ASSEMBLER        NEXTP LDL  GCALL ;

CR .( Runtime-Teil der Definitionsworte )
META IN-META
ALIGN-T
ASSEMBLER
LABEL NEST  W LDL   4 ADC  W STL   RP LDL  -4 ADC  RP STL
           IP LDL  RP LDL  0 STNL   W LDL  IP STL  NEXT END-CODE
LABEL DODOES       RP LDL  -4 ADC  RP STL  IP LDL  RP LDL  0 STNL IP STL
                    W LDL   4 ADC   W STL   W LDL  1PUSH  END-CODE
LABEL DOCREATE      W LDL   4 ADC   W STL   W LDL  1PUSH  END-CODE
LABEL DO2CREATE     W LDL   4 ADC   W STL   W LDL  1PUSH  END-CODE
\ DO2CREATE ist dasselbe wie DOCREATE. DOCREATE htte also gengt. Mit der
\ Verwendung von DO2CREATE in der Definition von 2VARIABLE ( siehe dort )
\ wird es aber dem Discompiler SEE ( siehe dort ) mglich, zwischen VARIA-
\ BLE und 2VARIABLE zu unterscheiden.
LABEL DOCONSTANT    W LDL   4 ADC   W STL   W LDL  0 LDNL  1PUSH  END-CODE
LABEL DO2CONSTANT
       SP LDL  -8 ADC  SP STL  W LDL  4 ADC   W STL
        W LDL  0 LDNL  SP LDL  0 STNL
        W LDL  1 LDNL  SP LDL  1 STNL  NEXT END-CODE
LABEL DOSTRING   \ 1 Byte max, 1 Byte count
       W LDL  4 ADC       W STL  SP LDL  -8 ADC  SP STL
       W LDL  2 ADC      SP LDL   1 STNL
       W LDL  1 ADC  LB  SP LDL   0 STNL  NEXT   END-CODE
LABEL DODEFER  W LDL  4 ADC   W STL
               W LDL  0 LDNL  W STL
               W LDL  0 LDNL  GCALL  END-CODE

HEX
META IN-META
ALIGN-T
HERE-T 2DUP 10 D+ CURRENT-T 2!          \ cfa von FORTH nach Abbild von CURRENT
VOCABULARY FORTH  FORTH DEFINITIONS
0 2OVER D4+ !-T ( Endstation fr FIND ) \ 0 nach lfa von FORTH
D4+ 2DUP 18 D+ !-T                      \ lfa von FORTH nach Strang "F"
META IN-META
ALIGN-T
CODE UNNEST  RP LDL  0 LDNL  IP STL  RP LDL  4 ADC  RP STL  NEXT END-CODE
CODE EXIT  ' UNNEST @-T ' EXIT !-T  END-CODE
FORCED VARIABLE UP UNFORCED
VARIABLE  ORG                           \ Systemanfang.
SERVER    ORG 2@ META  ORG !-T          \ Wird vom Server vorgegeben.
VARIABLE WPTR                           \ Workspace-Pointer zu Beginn.
SERVER   WPTR    META WPTR !-T          \ Wird vom Server vorgegeben.
VARIABLE  EOS                           \ End-of-System. Darauf basiere ich
SERVER    EOS 2@ META  EOS !-T          \ BUFFER und SP0 ( = EOS - 8*LBUF ).
                                        \ EOS kann im Server vorgegeben wer-
                                        \ den.
                                        \ Bei nderung  auch den User-Tabel-
         WPTR @-T 80 D+ UP !-T          \ len-Anfang ( siehe oben ) ndern !
 EOS @-T  1 ( Dateilnge  )             \ | Das
        0FF ( fr Datei   ) D+          \ | alles
          2 ( Dateinummer ) D+          \ | ist
         40 ( Dateiname   ) D+          \ | = LBUF
            ( FILES = 8   ) D2* D2* D2* \ mgliche Anzahl geffneter Dateien
            ( von EOS -   ) D-
  UP @-T 0C D+ !-T                      \ SP0 in User-Tabelle setzen.
                                        \ 0Ch = Byteoffset von SP0.

ALIGN-T
ASSEMBLER
LABEL DOUSER-VARIABLE
       W LDL  4 ADC  W STL
       W LDL  0 LDNL  UP LDC  0 LDNL  ADD  1PUSH END-CODE
LABEL USER-PUSH  \ Legt den Inhalt einer in Maschinencode gegebenen USER-
                 \ Variablen auf den Datenstack. USER-Offset in AREG.
       UP LDC  0 LDNL  AREG LDL  ADD  0 LDNL  1PUSH  NEXT END-CODE
LABEL DOUSER-DEFER
       W LDL  4 ADC  W STL
       W LDL  0 LDNL  UP LDC  0 LDNL  ADD
       0 LDNL  W STL   W LDL  0 LDNL  GCALL  END-CODE
META IN-META
ALIGN-T
CODE [']    ( -- n )
      IP LDL  0 LDNL  IP LDL  4 ADC  IP STL  1PUSH END-CODE
CODE (LIT)  ( -- n )
      IP LDL  0 LDNL  IP LDL  4 ADC  IP STL  1PUSH END-CODE
CODE (DLIT) ( -- d )
      SP LDL  -8 ADC  SP STL
      IP LDL  0 LDNL  SP LDL  0 STNL
      IP LDL  1 LDNL  SP LDL  1 STNL
      IP LDL  8 ADC   IP STL  NEXT END-CODE


CR .( Return-Stack, 2k in internem RAM, einrichten und initialisieren )
FORCED
VARIABLE  TIB0  ( Enthlt die Startadresse des Eingabepuffers )
VARIABLE 'TIB   ( Enthlt die Adresse des Eingabepuffers )
UNFORCED
ALIGN-T
HERE-T TIB0 !-T
HERE-T 'TIB !-T

800 ALLOT-T
HERE-T UP @-T 10 D+ !-T     \ 10h = Byteoffset von RP0 in USER-Tabelle

\ Vielleicht hiervon 1k fr Pseudostack ( PP PP0 usw ) abzwacken und
\ diesen fr DO-Schleifen verwenden, die dann beliebig geschachtelt
\ werden drfen ???

CR .( Kontrollstruktur-Worte )
CODE BRANCH  ( -- )
LABEL BRAN1  IP LDL  0 LDNL  IP STL  NEXT END-CODE
CODE ?BRANCH ( fl -- )  SP LDL  0 LDNL  SP LDL  4 ADC  SP STL
      BRAN1 HERE-T 2 D+ D-  CJ  IP LDL  4 ADC  IP STL  NEXT END-CODE
CODE (LOOP)  ( -- )
      TESTERR  RP LDL  0 LDNL  1 ADC  RP LDL  0 STNL  TESTERR  0 EQC
      BRAN1 HERE-T 2 D+ D-  CJ
      RP LDL  0C ADC  RP STL  IP LDL  4 ADC  IP STL  NEXT END-CODE
CODE (+LOOP) ( n -- )
      TESTERR  SP LDL  0 LDNL  SP LDL  4 ADC  SP STL
               RP LDL  0 LDNL  ADD    RP LDL  0 STNL  TESTERR  0 EQC
      BRAN1 HERE-T 2 D+ D-  CJ
      RP LDL  0C ADC  RP STL  IP LDL  4 ADC  IP STL  NEXT END-CODE
HEX
CODE (DO)   ( lim ini -- )
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  8 ADC  SP STL
LABEL PDO  RP LDL  -0C ADC  RP STL
      IP LDL  0 LDNL  RP LDL  2 STNL  IP LDL  4 ADC IP STL
      MINT  BREG LDL  ADD  BREG STL
      BREG LDL  RP LDL 1 STNL
      AREG LDL  BREG LDL  SUB  RP LDL  0 STNL  NEXT END-CODE
DECIMAL
CODE (?DO)  ( lim ini -- )
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      SP LDL  8 ADC  SP STL
      AREG LDL  BREG LDL  SUB
      0 EQC
      PDO HERE-T 2 D+ D-  CJ
      IP LDL  0 LDNL  IP STL  NEXT END-CODE
CODE BOUNDS ( ad len -- lim first )  \ first = ad, lim = ad+len
      SP LDL  0 LDNL  SP LDL  1 LDNL  SP LDL  0 STNL  SP LDL  1 LDNL  ADD
      SP LDL  1 STNL  NEXT END-CODE

HEX
CR .( Steuerung der Befehlsausfhrung )
ASSEMBLER >NEXT META 2CONSTANT >NEXT
CODE EXECUTE ( cfa -- )        SP LDL  0 LDNL          W STL
      SP LDL  4 ADC  SP STL  W LDL  0 LDNL  GCALL  END-CODE
CODE PERFORM ( ad-of-cfa -- )  SP LDL  0 LDNL  0 LDNL  W STL
      SP LDL  4 ADC  SP STL  W LDL  0 LDNL  GCALL  END-CODE
CODE GO      ( ad -- )         SP LDL  0 LDNL
      SP LDL  4 ADC  SP STL                 GCALL  END-CODE
CODE RESET START END-CODE
CODE NOOP   NEXT END-CODE
CODE PAUSE
      0 J   NEXT END-CODE
CODE I ( -- n ) RP LDL  0 LDNL  RP LDL  1 LDNL  ADD 1PUSH  END-CODE
CODE J ( -- n ) RP LDL  3 LDNL  RP LDL  4 LDNL  ADD 1PUSH  END-CODE
CODE K ( -- n ) RP LDL  6 LDNL  RP LDL  7 LDNL  ADD 1PUSH  END-CODE
CODE (LEAVE) ( -- )
      RP LDL  2 LDNL  IP STL  RP LDL  0C ADC  RP STL  NEXT END-CODE
CODE (?LEAVE) ( fl -- )
      SP LDL  0 LDNL  SP LDL  4 ADC  SP STL  0<>
      1IF  RP LDL  2 LDNL  IP STL  RP LDL  0C ADC  RP STL  THEN  NEXT END-CODE

CR .( 8- und 32-Bit-Speicheroperationen )
CODE @ ( ad -- n ) SP LDL  0 LDNL  0 LDNL  SP LDL  0 STNL  NEXT END-CODE
CODE ! ( n ad -- ) SP LDL  1 LDNL  SP LDL  0 LDNL  0 STNL
                   SP LDL  8 ADC   SP STL  NEXT  END-CODE
                   \ Fr 4-Byte-Zahlen, die an einer Wortgrenze liegen
CODE W@ ( ad -- n ) SP LDL  0 LDNL  DUP         LB  SP LDL         SB
                                    DUP  1 ADC  LB  SP LDL  1 ADC  SB
                                    DUP  2 ADC  LB  SP LDL  2 ADC  SB
                                         3 ADC  LB  SP LDL  3 ADC  SB
                    NEXT END-CODE
                    \ Fr 4-Byte-Zahlen, die beliebig im RAM liegen
CODE W! ( n ad -- ) SP LDL  4 ADC  LB  SP LDL  0 LDNL         SB
                    SP LDL  5 ADC  LB  SP LDL  0 LDNL  1 ADC  SB
                    SP LDL  6 ADC  LB  SP LDL  0 LDNL  2 ADC  SB
                    SP LDL  7 ADC  LB  SP LDL  0 LDNL  3 ADC  SB
                    SP LDL  8 ADC      SP STL    NEXT  END-CODE
                    \ Fr 4-Byte-Zahlen, die beliebig im RAM liegen
CODE C@ ( ad -- chr ) SP LDL  0 LDNL  LB  SP LDL  0 STNL  NEXT END-CODE
CODE C! ( chr ad -- ) SP LDL  1 LDNL  SP LDL  0 LDNL  SB
                      SP LDL  8 ADC   SP STL  NEXT  END-CODE
                      \ Fr 1-Byte-Zahlen, die beliebig im RAM liegen
CODE CC@ ( ad -- cc ) SP LDL  0 LDNL  DUP  LB  SP LDL         SB
                                    1 ADC  LB  SP LDL  1 ADC  SB
                                    0 LDC      SP LDL  2 ADC  SB
                                    0 LDC      SP LDL  3 ADC  SB
                      NEXT END-CODE
                      \ Fr 2-Byte-Zahlen, die beliebig im RAM liegen
CODE CC! ( cc ad -- ) SP LDL  4 ADC  LB  SP LDL  0 LDNL         SB
                      SP LDL  5 ADC  LB  SP LDL  0 LDNL  1 ADC  SB
                      SP LDL  8 ADC      SP STL    NEXT  END-CODE
                      \ Fr 2-Byte-Zahlen, die beliebig im RAM liegen

CR .( Blockverschiebungen im Speicher )
HEX
CODE CMOVE   ( from to len --  )      \ Kopieren vom ersten Byte her
      SP LDL  0 LDNL  BREG STL        \ Lnge vom Stack nach BREG
      BREG LDL  0 LDC  >              \ berspringen, wenn len  0
      2IF
      SP LDL  1 LDNL  CREG STL        \ Zieladresse     nach CREG
      SP LDL  2 LDNL  AREG STL        \ Quelladresse    nach AREG
      CREG LDL  AREG LDL  <>          \ berspringen, wenn Ziel = Quelle
      1IF
      AREG LDL  LB  CREG LDL  SB      \ Von laufender Quelle nach lauf. Ziel
      CREG LDL   1 ADC  CREG STL      \ Zieladresse um 1 erhhen
      AREG LDLP  0C LDC  LEND         \ An Schleifenanfang
      THEN
      THEN
      SP LDL  0C ADC  SP STL          \ Stackanpassung
      NEXT END-CODE
CODE CMOVE>  ( from to len -- )       \ Kopieren vom letzten Byte her
      SP LDL  0 LDNL  BREG STL        \ Lnge vom Stack nach BREG
      BREG LDL  0 LDC  >              \ berspringen, wenn len  0
      2IF
      SP LDL  1 LDNL  -1 ADC CREG STL \ Zieladresse-1    nach CREG
      SP LDL  2 LDNL  -1 ADC DREG STL \ Quelladresse-1   nach DREG
      CREG LDL  DREG LDL  <>          \ berspringen, wenn Ziel = Quelle
      1IF
      DREG LDL  BREG LDL  ADD  LB     \ Von Quelle + laufende Lnge
      CREG LDL  BREG LDL  ADD  SB     \ nach  Ziel + laufende Lnge
      AREG LDLP  0D LDC  LEND         \ AREG = Dummy; Kontrollstruktur-Beginn
      THEN
      THEN
      SP LDL  0C ADC  SP STL          \ Stackanpassung
      NEXT END-CODE
CODE <MOVE> ( from to len -- )        \ Kopieren, wenn keine berlappung
      SP LDL  2 LDNL  DREG STL        \ Quelladresse    nach DREG
      SP LDL  1 LDNL  CREG STL        \ Zieladresse     nach CREG
      SP LDL  0 LDNL  BREG STL        \ Lnge vom Stack nach BREG
      BREG LDL     0 LDC   >          \ berspringen, wenn len  0
      1IF
      CREG LDL  DREG LDL  <>          \ berspringen, wenn Ziel = Quelle
      1IF
      DREG LDL  CREG LDL  BREG LDL    \ from to len
      MOVE                            \ kopieren
      THEN
      THEN
      SP LDL  0C ADC  SP STL          \ Stackanpassung
      NEXT END-CODE                   \ Scheint auch bei berlappung zu gehen !


CR .( 32-Bit-Stack-Operationen )
HEX

CODE SP@  ( -- n ) SP LDL  1PUSH END-CODE
CODE SP!  ( n -- ) SP LDL  0 LDNL  SP STL  NEXT END-CODE
CODE RP@  ( -- n ) RP LDL  1PUSH END-CODE
CODE RP!  ( n -- ) SP LDL  0 LDNL  RP STL
                   SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE DROP ( n -- ) SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE DUP  ( n -- n n ) SP LDL  0 LDNL  1PUSH END-CODE
CODE SWAP ( n1 n2 -- n2 n1 ) SP LDL  0 LDNL  SP LDL  1 LDNL
                             SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE OVER ( n1 n2 -- n1 n2 n1 )
      SP LDL  1 LDNL  1PUSH END-CODE
CODE TUCK ( n1 n2 -- n2 n1 n2 )
      SP LDL  0 LDNL  DUP  AREG STL  SP LDL  1 LDNL
      SP LDL  0 STNL  SP LDL  1 STNL  AREG LDL  1PUSH END-CODE
CODE NIP  ( n1 n2 -- n2 )
      SP LDL  0 LDNL  SP LDL  1 STNL
      SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE ROT  ( n1 n2 n3 --- n2 n3 n1 )
      SP LDL  2 LDNL  SP LDL  1 LDNL
      SP LDL  2 STNL  SP LDL  0 LDNL
      SP LDL  1 STNL  SP LDL  0 STNL  NEXT END-CODE
CODE -ROT ( n1 n2 n3 --- n3 n1 n2 )
      SP LDL  0 LDNL  SP LDL  1 LDNL
      SP LDL  0 STNL  SP LDL  2 LDNL
      SP LDL  1 STNL  SP LDL  2 STNL  NEXT END-CODE
CODE ?DUP ( n -- n [n if <>0] )
      SP LDL  0 LDNL  0<>
      1IF  SP LDL  -4 ADC  SP STL  SP LDL  1 LDNL  SP LDL  0 STNL  THEN
      NEXT END-CODE
CODE R> ( -- n )
      RP LDL  0 LDNL  RP LDL  4 ADC  RP STL  1PUSH END-CODE
CODE >R ( n -- )
      SP LDL  0 LDNL  SP LDL  4 ADC  SP STL
      RP LDL  -4 ADC  RP STL  RP LDL  0 STNL  NEXT END-CODE
CODE R@ ( -- n )
      RP LDL  0 LDNL  1PUSH END-CODE
\ ------------------------ nicht F83
CODE DUP>R  ( n -- n )
      RP LDL  -4 ADC  RP STL
      SP LDL  0 LDNL  RP LDL  0 STNL  NEXT END-CODE

CODE R>DROP ( -- ) RP LDL  4 ADC  RP STL  NEXT END-CODE
\ ----------------------------------
CODE PICK ( nm ... n2 n1 k -- nm ... n2 n1 nk )
      SP LDL  0 LDNL  SP LDL  4 ADC  WSUB  0 LDNL
      SP LDL  0 STNL  NEXT END-CODE
CODE ROLL  ( nn ... n1 n0 n  --  ... n1 n0 nn )  \ 1 ROLL = SWAP usw.
        SP LDL    0 LDNL  EREG STL  \ n
        SP LDL     4 ADC    SP STL
      EREG LDL    SP LDL  WSUB
         0 LDNL FREG STL            \ nn
      EREG LDL      BCNT  BREG STL  \ Lnge
        SP LDL     3 ADC  CREG STL  \ Ziel-1
        SP LDL    -1 ADC  DREG STL  \ Quelle-1
      DREG LDL  BREG LDL  ADD LB
      CREG LDL  BREG LDL  ADD SB
      AREG LDLP   0D LDC  LEND      \ vergleiche CMOVE>
      FREG LDL    SP LDL  0 STNL  NEXT END-CODE

\ Der Rest dieses Abschnitts mit dem Wort -ROLL liegt jetzt in TCORE.FTH .
\ Der Server mit Cross-Assembler und Metacompiler waren zu gro geworden.


CR .( Byteweise Stack-Umordnungen )

CODE FLIP   ( n1 -- n2 )   \ n1 = abcd       ->  n2 = cdab
      SP LDL         LB  SP LDL  2 ADC  LB
      SP LDL         SB  SP LDL  2 ADC  SB
      SP LDL  1 ADC  LB  SP LDL  3 ADC  LB
      SP LDL  1 ADC  SB  SP LDL  3 ADC  SB  NEXT END-CODE
CODE CFLIP   ( n1 -- n2 )   \ n1 = abcd      ->  n2 = badc
      SP LDL         LB  SP LDL  1 ADC  LB
      SP LDL         SB  SP LDL  1 ADC  SB
      SP LDL  2 ADC  LB  SP LDL  3 ADC  LB
      SP LDL  2 ADC  SB  SP LDL  3 ADC  SB  NEXT END-CODE
CODE BYTEREV  ( n1 -- n2 )  \ n1 = abcd      ->  n2 = dcba
      SP LDL         LB  SP LDL  3 ADC  LB
      SP LDL         SB  SP LDL  3 ADC  SB
      SP LDL  1 ADC  LB  SP LDL  2 ADC  LB
      SP LDL  1 ADC  SB  SP LDL  2 ADC  SB  NEXT END-CODE
CODE 2BYTEREV  ( d1 -- d2 ) \ d1 = abcdefgh  ->  d2 = hgfedcba
      SP LDL         LB  SP LDL  7 ADC  LB
      SP LDL         SB  SP LDL  7 ADC  SB
      SP LDL  1 ADC  LB  SP LDL  6 ADC  LB
      SP LDL  1 ADC  SB  SP LDL  6 ADC  SB
      SP LDL  2 ADC  LB  SP LDL  5 ADC  LB
      SP LDL  2 ADC  SB  SP LDL  5 ADC  SB
      SP LDL  3 ADC  LB  SP LDL  4 ADC  LB
      SP LDL  3 ADC  SB  SP LDL  4 ADC  SB  NEXT END-CODE
CODE BITCNT ( n -- cnt )  \ cnt = Anzahl der gesetzten Bits in n
      0 LDC  SP LDL  0 LDNL  BITCNT  SP LDL  0 STNL  NEXT END-CODE
CODE BITREV ( n1 -- n2 )  \ n2 = n1 bitweise gespiegelt
      SP LDL  0 LDNL  BITREVWORD  SP LDL  0 STNL  NEXT END-CODE
CODE BITREVN ( n1 cnt -- n2 )
      \ Die unteren cnt Bits werden um ihre Mittelachse gespiegelt,
      \ die verbleibenden hheren Bits werden auf 0 gesetzt
      SP LDL  1 LDNL  SP LDL  0 LDNL  BITREVNBITS
      SP LDL  1 STNL  SP LDL  4 ADC   SP STL  NEXT END-CODE

CR .( 32-Bit-Logik-Operationen )

CODE AND ( n1 n2 -- n3 )  SP LDL  0 LDNL  SP LDL  1 LDNL  AND  SP LDL  1 STNL
                          SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE OR  ( n1 n2 -- n3 )  SP LDL  0 LDNL  SP LDL  1 LDNL  OR   SP LDL  1 STNL
                          SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE XOR ( n1 n2 -- n3 )  SP LDL  0 LDNL  SP LDL  1 LDNL  XOR  SP LDL  1 STNL
                          SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE NOT ( n -- n' ) SP LDL  0 LDNL  NOT  SP LDL  0 STNL  NEXT END-CODE
CODE TRUE  -1 LDC  1PUSH END-CODE  \ Fr den T800-Code ist TRUE = 1  !!!
CODE FALSE  0 LDC  1PUSH END-CODE
CODE CSET    ( b ad -- )
      SP LDL  0 LDNL  LB  SP LDL  1 LDNL  OR
      SP LDL  0 LDNL  SB  SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE CRESET  ( b ad -- )
      SP LDL  0 LDNL  LB  SP LDL  1 LDNL  NOT  AND
      SP LDL  0 LDNL  SB  SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE CTOGGLE ( b ad -- )
      SP LDL  0 LDNL  LB  SP LDL  1 LDNL  XOR
      SP LDL  0 LDNL  SB  SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE ON  ( ad -- ) -1 LDC  SP LDL  0 LDNL  0 STNL
                           SP LDL  4 ADC   SP STL  NEXT END-CODE
CODE OFF ( ad -- )  0 LDC  SP LDL  0 LDNL  0 STNL
                           SP LDL  4 ADC   SP STL  NEXT END-CODE

CR .( Arithmetische 32-Bit-Operationen )

CODE +       ( n1 n2 -- n )    \ n = n1+n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  SUM
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE ADD     ( n1 n2 -- n fl ) \ n = n1+n2 ; Flag = FALSE bei berlauf
      TESTERR  SP LDL  1 LDNL  SP LDL  0 LDNL  ADD
      TESTERR  NOT  1 ADC  SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE -       ( n1 n2 -- n )    \ n = n1-n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  DIFF
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE SUB     ( n1 n2 -- n fl ) \ n = n1-n2 ) ; Flag = FALSE bei berlauf
      TESTERR  SP LDL  1 LDNL  SP LDL  0 LDNL  SUB
      TESTERR  NOT  1 ADC  SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE NEGATE  ( n -- -n )
LABEL NEGAT  SP LDL  0 LDNL  NOT  1 ADC  SP LDL  0 STNL  NEXT END-CODE
CODE ?NEGATE ( n1 n2 -- n )  \ n = -n1, wenn n2 < 0, sonst n = n1
      SP LDL  4 ADC  SP STL  0 LDC  SP LDL  -1 LDNL  GT
      0 EQC  NEGAT HERE-T 2 D+ D-  CJ  NEXT END-CODE
CODE ABS     ( n -- n )
      0 LDC  SP LDL  0 LDNL  GT
      0 EQC  NEGAT HERE-T 2 D+ D-  CJ  NEXT END-CODE
CODE +! ( n ad -- )
      SP LDL  1 LDNL  SP LDL  0 LDNL  0 LDNL  ADD  SP LDL  0 LDNL  0 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE

DECIMAL
CR .( Konstanten, in Maschinensprache neu definiert )

CODE 0  0 LDC 1PUSH END-CODE
CODE 1  1 LDC 1PUSH END-CODE
CODE 2  2 LDC 1PUSH END-CODE
CODE 3  3 LDC SP LDL  -4 ADC  SP STL  SP LDL  0 STNL  NEXT END-CODE

CODE  2* ( n --  2*n )  SP LDL 0 LDNL   1 LDC      SHL SP LDL 0 STNL NEXT END-CODE
CODE  4* ( n --  4*n )  SP LDL 0 LDNL             BCNT SP LDL 0 STNL NEXT END-CODE
CODE  8* ( n --  8*n )  SP LDL 0 LDNL   3 LDC      SHL SP LDL 0 STNL NEXT END-CODE
CODE 16* ( n -- 16*n )  SP LDL 0 LDNL        BCNT BCNT SP LDL 0 STNL NEXT END-CODE
CODE  2/ ( n -- n/2 )   SP LDL 0 LDNL XDBLE 1 LDC LSHR SP LDL 0 STNL NEXT END-CODE
CODE  4/ ( n -- n/4 )   SP LDL 0 LDNL             WCNT SP LDL 0 STNL NEXT END-CODE
CODE  8/ ( n -- n/8 )   SP LDL 0 LDNL XDBLE 3 LDC LSHR SP LDL 0 STNL NEXT END-CODE
CODE 16/ ( n -- n/16 )  SP LDL 0 LDNL        WCNT WCNT SP LDL 0 STNL NEXT END-CODE
CODE U2/  ( u -- u/2 )  SP LDL 0 LDNL   1 LDC      SHR SP LDL 0 STNL NEXT END-CODE
CODE U4/  ( u -- u/4 )  SP LDL 0 LDNL   2 LDC      SHR SP LDL 0 STNL NEXT END-CODE
CODE U8/  ( u -- u/8 )  SP LDL 0 LDNL   3 LDC      SHR SP LDL 0 STNL NEXT END-CODE
CODE U16/ ( u -- u/16 ) SP LDL 0 LDNL   4 LDC      SHR SP LDL 0 STNL NEXT END-CODE
CODE 1+  ( n -- n+1 )   SP LDL 0 LDNL   1 ADC          SP LDL 0 STNL NEXT END-CODE
CODE 2+  ( n -- n+2 )   SP LDL 0 LDNL   2 ADC          SP LDL 0 STNL NEXT END-CODE
CODE 4+  ( n -- n+4 )   SP LDL 0 LDNL   4 ADC          SP LDL 0 STNL NEXT END-CODE
CODE 1-  ( n -- n-1 )   SP LDL 0 LDNL  -1 ADC          SP LDL 0 STNL NEXT END-CODE
CODE 2-  ( n -- n-2 )   SP LDL 0 LDNL  -2 ADC          SP LDL 0 STNL NEXT END-CODE
CODE 4-  ( n -- n-4 )   SP LDL 0 LDNL  -4 ADC          SP LDL 0 STNL NEXT END-CODE

CODE 1+! ( ad ---) \ Den Inhalt der Wort-Adresse ad um 1 erhhen
      SP LDL  0 LDNL    DUP  0 LDNL  1 ADC  REV  0 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE 1-! ( ad ---) \ Den Inhalt der Wort-Adresse ad um 1 erniedrigen
      SP LDL  0 LDNL    DUP  0 LDNL -1 ADC  REV  0 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE 1+C! ( ad ---) \ Den Inhalt der Byte-Adresse ad um 1 erhhen
      SP LDL  0 LDNL    DUP  LB  1 ADC  REV  SB
      SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE 1-C! ( ad ---) \ Den Inhalt der Byte-Adresse ad um 1 erniedrigen
      SP LDL  0 LDNL    DUP  LB -1 ADC  REV  SB
      SP LDL  4 ADC  SP STL  NEXT END-CODE
      \ Wird fr Count-Bytes von Strings bentigt,
      \ die nicht an Wortgrenzen liegen

CR .( 32-Bit-Multiplikation ohne Vorzeichen )

CODE UM*  ( u1 u2 -- ud )
       0 LDC  SP LDL  0 LDNL  SP LDL  1 LDNL  LMUL
      SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE U*D  ( u1 u2 -- ud )     \ identisch mit UM*
       0 LDC  SP LDL  0 LDNL  SP LDL  1 LDNL  LMUL
      SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE

CR .( 32-Bit-Division ohne Vorzeichen )

CODE UM/MOD ( ud u1 -- u2 u3 )  \ u2 = Rest, u3 = ud/u1
      SP LDL  2 LDNL  SP LDL  1 LDNL  SP LDL  0 LDNL  LDIV
      SP LDL  1 STNL  SP LDL  2 STNL
      SP LDL  4 ADC   SP STL  NEXT END-CODE

DECIMAL
CR .( 32-Bit-Vergleichsoperationen )

CODE =  ( n1 n2 -- fl )     \ n1 = n2
      SP LDL  0 LDNL  SP LDL  1 LDNL  XOR  0 EQC  -1 ADC  NOT
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE <> ( n1 n2 -- fl )     \ n1 <> n2
      SP LDL  0 LDNL  SP LDL  1 LDNL  XOR  0 EQC  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE <  ( n1 n2 -- fl )     \ n1 < n2
      SP LDL  0 LDNL  SP LDL  1 LDNL  GT  -1 ADC  NOT
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE >  ( n1 n2 -- fl )     \ n1 > n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  GT  -1 ADC  NOT
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE <= ( n1 n2 -- fl )     \ n1 <= n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  GT  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE >= ( n1 n2 -- fl )     \ n1 >= n2
      SP LDL  0 LDNL  SP LDL  1 LDNL  GT  -1 ADC
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE 0=  ( n -- fl )        \ n = 0
      SP LDL  0 LDNL  0 EQC  -1 ADC  NOT  SP LDL  0 STNL  NEXT END-CODE
CODE 0<> ( n -- fl )        \ n <> 0
      SP LDL  0 LDNL  0 EQC  -1 ADC       SP LDL  0 STNL  NEXT END-CODE
CODE 0<  ( n -- fl )        \ n < 0
      SP LDL  0 LDNL  XDBLE  REV       SP LDL  0 STNL  NEXT END-CODE
CODE 0>  ( n -- fl )        \ n > 0
      SP LDL  0 LDNL  0 LDC  GT  -1 ADC  NOT  SP LDL  0 STNL  NEXT END-CODE
CODE 0<= ( n -- fl )        \ n <= 0
      SP LDL  0 LDNL  0 LDC  GT  -1 ADC       SP LDL  0 STNL  NEXT END-CODE
CODE 0>= ( n -- fl )        \ n >= 0
      SP LDL  0 LDNL  XDBLE  REV  NOT  SP LDL  0 STNL  NEXT END-CODE
CODE U< ( u1 u2 -- fl )     \ u1 < u2
      TESTERR  SP LDL  1 LDNL  SP LDL  0 LDNL  CSUB0 TESTERR
      -1 ADC  NOT  SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE U> ( u1 u2 -- fl )     \ u1 > u2
      TESTERR  SP LDL  0 LDNL  SP LDL  1 LDNL  CSUB0 TESTERR
      -1 ADC  NOT  SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE U<= ( u1 u2 -- fl )    \ u1  u2
      TESTERR  SP LDL  0 LDNL  SP LDL  1 LDNL  CSUB0 TESTERR
      -1 ADC       SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE U>= ( u1 u2 -- fl )    \ u1  u2
      TESTERR  SP LDL  1 LDNL  SP LDL  0 LDNL  CSUB0 TESTERR
      -1 ADC       SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE MIN ( n1 n2 -- n )   \ n = min{n1,n2}
      SP LDL  0 LDNL  AREG STL
      SP LDL  0 LDNL  SP LDL  1 LDNL  GT
      3 CJ  SP LDL  1 LDNL  AREG STL  AREG LDL  SP LDL  1 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE MAX ( n1 n2 -- n )   \ n = max{n1,n2}
      SP LDL  1 LDNL  AREG STL
      SP LDL  0 LDNL  SP LDL  1 LDNL  GT
      3 CJ  SP LDL  0 LDNL  AREG STL  AREG LDL  SP LDL  1 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE BETWEEN ( n min max -- fl )  \ min  n  max
      SP LDL  2 LDNL  SP LDL  0 LDNL  GT  -1 ADC
      SP LDL  1 LDNL  SP LDL  2 LDNL  GT  -1 ADC  AND
      SP LDL  2 STNL  SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE WITHIN  ( n min max -- fl )  \ min  n < max
      SP LDL  0 LDNL  SP LDL  2 LDNL  GT  -1 ADC  NOT
      SP LDL  1 LDNL  SP LDL  2 LDNL  GT  -1 ADC  AND
      SP LDL  2 STNL  SP LDL  8 ADC  SP STL  NEXT END-CODE

CR .( 64-Bit-Speicheroperationen )

CODE 2@ ( ad -- d )
      SP LDL  0 LDNL  DUP  1 LDNL  SP LDL  0 STNL  0 LDNL  1PUSH END-CODE
CODE 2! ( d ad -- ) SP LDL  2 LDNL  SP LDL  0 LDNL  1 STNL
                    SP LDL  1 LDNL  SP LDL  0 LDNL  0 STNL
                    SP LDL  12 ADC  SP STL  NEXT  END-CODE


CR .( 64-Bit-Stackoperationen )
DECIMAL

CODE 2DROP ( d -- )  SP LDL  8 ADC  SP STL  NEXT END-CODE
CODE 2DUP ( d -- d d )
      SP LDL  -8 ADC  SP STL  SP LDL  3 LDNL  SP LDL  1 STNL
      SP LDL  2 LDNL  SP LDL  0 STNL  NEXT END-CODE
CODE 2SWAP ( d1 d2 -- d2 d1 )
      SP LDL  0 LDNL  SP LDL  2 LDNL
      SP LDL  0 STNL  SP LDL  2 STNL
      SP LDL  1 LDNL  SP LDL  3 LDNL
      SP LDL  1 STNL  SP LDL  3 STNL  NEXT END-CODE
CODE 3DUP ( a b c -- a b c a b c )
      SP LDL  -12 ADC  SP STL
      SP LDL  5 LDNL  SP LDL  2 STNL  SP LDL  4 LDNL  SP LDL  1 STNL
      SP LDL  3 LDNL  SP LDL  0 STNL  NEXT END-CODE

\ Der Rest dieses Abschnitts mit den Worten 2OVER 4DUP 2ROT 2-ROT 2NIP
\ 2TUCK 2PICK 2ROLL 2-ROLL liegt jetzt in TCORE.FTH . Der Server mit
\ Cross-Assembler und Metacompiler waren zu gro geworden.


CR .( 64-Bit-Logik-Operationen )

\ Dieser Abschnitt mit den Worten 2AND 2OR 2XOR 2NOT liegt jetzt in
\ TCORE.FTH . Der Server mit Cross-Assembler und Metacompiler waren
\ zu gro geworden.

CR .( Arithmetische 64-Bit-Operationen )

CODE D+   ( d1 d2 -- d )      \ d = d1+d2
       0 LDC
      SP LDL  2 LDNL  SP LDL  0 LDNL  LSUM   SP LDL  2 STNL
      SP LDL  3 LDNL  SP LDL  1 LDNL  LSUM   SP LDL  3 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE
CODE DADD ( d1 d2 -- d fl )   \ d = d1+d2 ; fl = FALSE bei berlauf
       0 LDC
      SP LDL  2 LDNL  SP LDL  0 LDNL  LSUM   SP LDL  2 STNL
      SP LDL  3 LDNL  SP LDL  1 LDNL  LSUM   SP LDL  3 STNL
       1 EQC  -1 ADC  SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE D-   ( d1 d2 -- d )      \ d = d1-d2
       0 LDC
      SP LDL  2 LDNL  SP LDL  0 LDNL  LDIFF  SP LDL  2 STNL
      SP LDL  3 LDNL  SP LDL  1 LDNL  LDIFF  SP LDL  3 STNL
      SP LDL  8 ADC   SP STL  NEXT END-CODE
CODE DSUB ( d1 d2 -- d fl )   \ d = d1-d2 ; f = FALSE bei Unterlauf
       0 LDC
      SP LDL  2 LDNL  SP LDL  0 LDNL  LDIFF  SP LDL  2 STNL
      SP LDL  3 LDNL  SP LDL  1 LDNL  LDIFF  SP LDL  3 STNL
       1 EQC  -1 ADC  SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE DNEGATE ( d -- -d )
LABEL DNEGAT
      0 LDC
      0 LDC  SP LDL  0 LDNL  LDIFF  SP LDL  0 STNL
      0 LDC  SP LDL  1 LDNL  LDIFF  SP LDL  1 STNL  NEXT END-CODE
CODE ?DNEGATE ( d1 n -- d2 ) \ d2 = -d1, wenn n<0, sonst d2 = d1
      SP LDL  4 ADC  SP STL  0 LDC  SP LDL  -1 LDNL  GT
      0 EQC  DNEGAT HERE-T 2 D+ D-  CJ  NEXT END-CODE
CODE S>D      ( n -- d )
      SP LDL  0 LDNL  XDBLE  REV  SP LDL  0 STNL  1PUSH  END-CODE
CODE D>S      ( d -- n fl )       \ Doppelwort - Wort; kein Wort
      TESTERR                     \ f=0, wenn kein Platz in Wort
      SP LDL  1 LDNL  SP LDL  0 LDNL  CSNGL  TESTERR  NOT  1 ADC
      SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE DABS     ( d -- d )
      SP LDL  1 LDNL  MINT  AND
      0 EQC  DNEGAT HERE-T 2 D+ D-  CJ  NEXT END-CODE
CODE D2*      ( d -- d*2 )
      SP LDL  1 LDNL  SP LDL  0 LDNL  1 LDC  LSHL
      SP LDL  0 STNL  SP LDL  1 STNL  NEXT END-CODE
CODE D2/      ( d -- d/2 )
      SP LDL  1 LDNL      MINT     AND  AREG STL
      SP LDL  1 LDNL    SP LDL  0 LDNL     1 LDC    LSHR
      SP LDL  0 STNL  AREG LDL      OR    SP LDL  1 STNL  NEXT END-CODE


CR .( 64-Bit-Vergleichsoperationen )

\ Dieser Abschnitt mit den Worten D= D<> D0= D0<> D0< D0>= D0> D0<= DU>
\ DU< DU<= DU>= D> D< D<= D>= DMAX DMIN  und  dem  Label DGREATER liegt
\ jetzt in TCORE.FTH .  Der Server mit Cross-Assembler und Metacompiler
\ waren zu gro geworden.


DECIMAL
CR .( Gemischte arithmetische Operationen )

CODE *D   ( n1 n2 -- d ) \ d = n1 * n2
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      AREG LDL  MINT  AND  BREG LDL  MINT  AND
      XOR  0 EQC  CREG STL                 \  = 0, wenn Produkt negativ
      AREG LDL  MINT  AND                  \ <> 0, wenn n2 negativ
      5 CJ  AREG LDL  NOT  1 ADC  AREG STL
      BREG LDL  MINT  AND                  \ <> 0, wenn n1 negativ
      5 CJ  BREG LDL  NOT  1 ADC  BREG STL
      0 LDC  AREG LDL  BREG LDL  LMUL
      AREG STL  BREG STL  CREG LDL  0 EQC  \ <> 0, wenn Produkt negativ
      15 CJ  0 LDC  AREG LDL  NOT  1 LDC  LSUM  AREG STL
                    BREG LDL  NOT  0 LDC  LSUM  BREG STL
      AREG LDL  SP LDL  0 STNL  BREG LDL  SP LDL  1 STNL  NEXT END-CODE
CODE SM/REM ( d n1 -- n2 n3 )               \ n2 = Rest, n3 = d/n1
      SP LDL  0 LDNL  AREG STL             \ keine floored division
      SP LDL  1 LDNL  BREG STL             \ sig(n2) = sig(d)
      SP LDL  2 LDNL  CREG STL
      AREG LDL  MINT  AND  CREG LDL  MINT  AND
      XOR  DREG STL                        \ <> 0, wenn Quotient negativ
      AREG LDL  MINT  AND                  \ <> 0, wenn n1 negativ
      5 CJ  AREG LDL  NOT  1 ADC  AREG STL
      CREG LDL  MINT  AND    DUP  EREG STL \ <> 0, wenn d negativ
      15 CJ  0 LDC  BREG LDL  NOT  1 LDC  LSUM  BREG STL
                    CREG LDL  NOT  0 LDC  LSUM  CREG STL
      CREG LDL  BREG LDL  AREG LDL  LDIV
      AREG STL  BREG STL  DREG LDL         \ <> 0, wenn Quotient negativ
      5 CJ  AREG LDL  NOT  1 ADC  AREG STL
      EREG LDL  MINT  AND                  \ <> 0, wenn d negativ
      5 CJ  BREG LDL  NOT  1 ADC  BREG STL
      AREG LDL  SP LDL  1 STNL
      BREG LDL  SP LDL  2 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
\ Dieses Wort hatte ich zuerst M/MOD genannt, aber so wie oben mit symme-
\ trischer Rundung angesetzt.  SM/REM ist die in ANS-Forth vorgeschlagene
\ Bezeichnung. M/MOD im Sinne von Forth 83, mit "floored division", liegt
\ jetzt in TCORE.FTH.
CODE MU/MOD  ( ud1 u1 -- u2 ud2 ) \ u2 = Rest, ud2 = ud1/u1
      0 LDC  SP LDL  2 LDNL  SP LDL  0 LDNL  LDIV  AREG STL
             SP LDL  1 LDNL  SP LDL  0 LDNL  LDIV
             SP LDL  0 STNL  SP LDL  2 STNL  AREG LDL
                             SP LDL  1 STNL  NEXT END-CODE

CR .( 32-Bit-Multiplikation und -Division, floored division )

CODE *    ( n1 n2 -- n ) \ n = n1*n2 ; luft bei n2<n1 schneller als bei n1<n2
      SP LDL  1 LDNL  SP LDL  0 LDNL  PROD
      SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE /MOD ( n1 n2 -- n3 n4 )  \ n3 = Rest von n1/n2 ; n4 = n1/n2
      SP LDL  0 LDNL  AREG STL  SP LDL  1 LDNL  BREG STL
      BREG LDL  AREG LDL  DIV   CREG STL
      BREG LDL  AREG LDL  REM   DREG STL
      DREG LDL 0<>
      2IF
           AREG LDL 0<  BREG LDL 0<  XOR  CREG LDL 0=  AND
           CREG LDL 0<  DREG LDL 0<> AND  OR
           2IF
                CREG LDL    -1 ADC       CREG STL
                DREG LDL  AREG LDL  ADD  DREG STL
           THEN
      THEN
      CREG LDL  SP LDL  0 STNL
      DREG LDL  SP LDL  1 STNL
      NEXT END-CODE
: /   ( n1 n2 -- n )  \ n = [n1/n2] ; floored division
      /MOD NIP ;
: MOD ( n1 n2 -- n )  \ n = Rest von n1/n2 bei floored division
      /MOD DROP ;
: */MOD ( n1 n2 n3 -- n4 n5 ) \ = n1 n2 *D n3 SM/REM
      >R  *D  R>  SM/REM  ;
: */    ( n1 n2 n3 --    n5 )  */MOD NIP ;

CR .( 32-Bit-Multiplikation und -Division, symmetrische Rundung )

\ Dieser Abschnitt mit den Worten MUL, S/REM, S/ und SREM  liegt jetzt
\ in TCORE.FTH.  Der Server mit Cross-Assembler und Metacompiler waren
\ zu gro geworden.


CR .( Task-abhngige USER-Variablen )

USER DEFINITIONS
VARIABLE  TOS      ( Rettet bei Taskwechsel Top-of-Stack )
VARIABLE  ENTRY    ( Hlt etwas Maschinencode fr Round-Robin-Task-Scheduler )
VARIABLE  LINK     ( Zeigt auf nchsten Task )
VARIABLE  SP0      ( Datenstack-Anfangswert )
VARIABLE  RP0      ( Returnstack-Anfangswert )
VARIABLE  DP       ( Dictionary-Pointer )
VARIABLE  #OUT     ( Zahl der ausgegebenen Zeichen )
VARIABLE  #LINE    ( Anzahl ausgegebener Zeilen )
VARIABLE  HANDLE   ( File-Handler, Erkennungsnummer der laufenden Datei )
VARIABLE  BASE     ( Zahlenbasis fr Ein-/Ausgabe )
VARIABLE  HLD      ( Zeigt auf zuletzt nach PAD gelegtes Zeichen )
VARIABLE  PRINTING ( Boolesche Variable, ON/OFF fr Drucken )
VARIABLE  ECHO     ( Boolesche Variable, ON/OFF fr Bildschirmausgabe )

CR .( System-VARIABLEn )

DEFER     EMIT    ( Multitaskfhige, vektorisierte Zeichenanzeige )
META DEFINITIONS
VARIABLE  PRIOR   ( Vokabular, in dem zuletzt gesucht wurde )
VARIABLE  STATE   ( Compilation oder Interpretation )
VARIABLE  WARNING ( Warnung vor Namensdoppelbelegung )
VARIABLE  DPL     ( Stellung des Punktes bei Eingabe von doppeltgenauen Zahlen )
VARIABLE  LAST    ( NFA des zuletzt eingegebenen Wortes )
VARIABLE  CSP     ( Check-Stack-Position; hlt Stackposition fest )
VARIABLE  CURRENT ( Vokabular, das momentan die Definitionen aufnimmt )
CODE #VOCS        ( Zahl der gleichzeitig mglichen CONTEXT-Vokabulare )
      8 LDC  1PUSH END-CODE
VARIABLE  CONTEXT ( Tabelle der zu durchsuchenden Vokabulare )
      0 , 0 , 0 , 0 , 0 , 0 , 0 ,
\ VARIABLE  'TIB  jetzt bei RP0 und dem Returnstack. TIB0 dort von mir neu !!!
VARIABLE  AVOC     ( Zur Zwischenspeicherung des Inhalts von CONTEXT )
VARIABLE  WIDTH    ( Maximale Lnge der Wortnamen )
VARIABLE  VOC-LINK ( Zeiger auf das zuletzt definierte Vokabular )
VARIABLE  >IN      ( Eingabestrom-Zeiger )
VARIABLE  SPAN   ( Anzahl der von EXPECT empfangenen und gespeicherten Zeichen )
VARIABLE  #TIB     ( Anzahl der Zeichen im Eingabepuffer )
VARIABLE  END?     ( Boolesche Variable; TRUE, wenn Eingabestrom erschpft )

DECIMAL
CR .( Vordefinierte Konstanten )

CODE BL  32 LDC  1PUSH  END-CODE
CODE BS   8 LDC  1PUSH  END-CODE
CODE BELL 7 LDC  1PUSH  END-CODE

CR .( Stringverarbeitung )

VARIABLE CAPS
CODE FILL ( ad len c -- )             \ Fllt len Bytes ab ad mit c
        SP LDL  1 LDNL  BREG STL      \ Lnge vom Stack nach BREG
      BREG LDL  0 LDC  >              \ berspringen, wenn len  0
      2IF
        SP LDL  2 LDNL  AREG STL      \ Anfangsadresse  nach AREG
        SP LDL  0 LDNL  CREG STL      \ Zeichen         nach CREG
      CREG LDL  AREG LDL  SB          \ Schleife
      AREG LDLP  8 LDC  LEND
      THEN
      SP LDL  12 ADC  SP STL          \ Stackanpassung
      NEXT END-CODE
: ERASE ( ad len -- )  0 FILL ;
: BLANK ( ad len -- ) BL FILL ;
CODE COUNT ( ad -- ad+1 len )
     SP LDL  0 LDNL  LB  SP LDL  0 LDNL  1 ADC  SP LDL  0 STNL  1PUSH  END-CODE
CODE LENGTH ( ad -- ad+4 len )  \ = COUNT fr Strings mit Lnge in 4 Byte
     SP LDL  0 LDNL  0 LDNL
     SP LDL  0 LDNL  4 ADC  SP LDL  0 STNL  1PUSH  END-CODE
: MOVE      ( from to len -- )          \ Fr berlappung mit "Automatik"
      -ROT 2DUP U< IF ROT CMOVE> ELSE ROT CMOVE THEN ;
CODE UPC ( chr -- chr' )  \ chr' = Grobuchstabe zu chr, auch ,,
      SP LDL  LB  AREG STL
      AREG LDL  96 LDC  GT  123 LDC  AREG LDL  GT  AND
      1IF  AREG LDL  32 LDC  SUB  AREG STL  THEN
      AREG LDL  132 EQC  1IF  142 LDC  AREG STL  THEN
      AREG LDL  148 EQC  1IF  153 LDC  AREG STL  THEN
      AREG LDL  129 EQC  1IF  154 LDC  AREG STL  THEN
      AREG LDL  SP LDL  SB  NEXT END-CODE
CODE UPPER ( ad len -- )     \ Wandelt alle Buchstaben in Grobuchstaben )
      SP LDL  0 LDNL  CREG STL  \ Lnge
      SP LDL  1 LDNL  BREG STL  \ Adresse
      BEGIN  CREG LDL  0<>  2WHILE
      BREG LDL  LB  AREG STL
      AREG LDL  96 LDC  GT  123 LDC  AREG LDL  GT  AND
      1IF  AREG LDL  32 LDC  SUB  AREG STL  THEN
      AREG LDL  132 EQC  1IF  142 LDC  AREG STL  THEN
      AREG LDL  148 EQC  1IF  153 LDC  AREG STL  THEN
      AREG LDL  129 EQC  1IF  154 LDC  AREG STL  THEN
      AREG LDL  BREG LDL  SB
      BREG LDL   1 ADC  BREG STL
      CREG LDL  -1 ADC  CREG STL
      REPEAT
      SP LDL 8 ADC SP STL  NEXT END-CODE

\ CODE HERE  ( -- ad )
\       UP LDC  0 LDNL  5 LDNL  \ 5 = Wortoffset von DP in USER-Tabelle
\       1PUSH  END-CODE                           \ gendert am 15.5.95
CODE HERE ( -- ad )
      37 LDL  1PUSH  END-CODE   \ 37d = WPTR-Wortoffset von DP in USER-Tabelle

: PAD  HERE 255 + ;
: -TRAILING  ( ad len -- ad len' ) DUP 0
      ?DO 2DUP + 1- C@ BL <> ?LEAVE 1- LOOP ;
ASSEMBLER
LABEL NOMORE  SP LDL  0 STNL  NEXT END-CODE
CODE COMP ( ad1 ad2 len -- fl ) \ fl = -1 | 0 | 1 , wenn ad1 < | = | > ad2
      SP LDL  2 LDNL  AREG STL  \ ad1
      SP LDL  1 LDNL  BREG STL  \ ad2
      SP LDL  0 LDNL  CREG STL  \ len
      SP LDL  8 ADC     SP STL
                      CREG LDL
      NOMORE HERE-T 2 D+ D- CJ
      BEGIN
        AREG LDL  LB  BREG LDL  LB  GT
                                   DREG STL
        BREG LDL  LB  AREG LDL  LB  GT
        NOT  1 ADC  DREG LDL  ADD  DREG STL
        AREG LDL   1 ADC  AREG STL
        BREG LDL   1 ADC  BREG STL
        CREG LDL  -1 ADC  CREG STL
        CREG LDL   0 EQC  DREG LDL  OR
      UNTIL
      DREG LDL  SP LDL  0 STNL  NEXT END-CODE
CODE CAPS-COMP ( ad1 ad2 len -- fl ) \ fl = -1 | 0 | 1 , wenn ad1 < | = | > ad2
      SP LDL  2 LDNL  AREG STL  \ ad1
      SP LDL  1 LDNL  BREG STL  \ ad2
      SP LDL  0 LDNL  CREG STL  \ len
      SP LDL  8 ADC     SP STL
                      CREG LDL
      NOMORE HERE-T 2 D+ D- CJ
      BEGIN
        AREG LDL  LB  EREG STL  \ [EREG] = Grobuchstabe zu [[AREG]], auch ,,
        EREG LDL  96 LDC  GT  123 LDC  EREG LDL  GT  AND
        1IF  EREG LDL  32 LDC  SUB  EREG STL  THEN
        EREG LDL  132 EQC  1IF  142 LDC  EREG STL  THEN
        EREG LDL  148 EQC  1IF  153 LDC  EREG STL  THEN
        EREG LDL  129 EQC  1IF  154 LDC  EREG STL  THEN
        BREG LDL  LB  FREG STL  \ [FREG] = Grobuchstabe zu [[BREG]], auch ,,
        FREG LDL  96 LDC  GT  123 LDC  FREG LDL  GT  AND
        1IF  FREG LDL  32 LDC  SUB  FREG STL  THEN
        FREG LDL  132 EQC  1IF  142 LDC  FREG STL  THEN
        FREG LDL  148 EQC  1IF  153 LDC  FREG STL  THEN
        FREG LDL  129 EQC  1IF  154 LDC  FREG STL  THEN
        EREG LDL  FREG LDL  GT                             DREG STL
        FREG LDL  EREG LDL  GT  NOT  1 ADC  DREG LDL  ADD  DREG STL
        AREG LDL   1 ADC  AREG STL
        BREG LDL   1 ADC  BREG STL
        CREG LDL  -1 ADC  CREG STL
        CREG LDL   0 EQC  DREG LDL  OR
      UNTIL
      DREG LDL  SP LDL  0 STNL  NEXT END-CODE
: COMPARE ( ad1 ad2 len -- -1 | 0 | 1 )
     CAPS @ IF CAPS-COMP ELSE COMP THEN ;


CR .( Cursor-Verwaltung )
DECIMAL

CODE (AT)     ( col row -- )          \ Cursor setzen
      MINT          3 LDC   OUTBYTE   \ Transfer-Funktion
      MINT          2 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTBYTE   \ col vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ row vom Stack
      NEXT END-CODE
: AT ( col row -- )  ( 0 0 ist linke obere Ecke )
      NOOP #LINE ! #OUT ! ;
\ Wird initialisiert durch  ' (AT) IS AT
CODE (CURSOR) ( -- col row )          \ Liefert Cursor-Position
      MINT          4 LDC   OUTBYTE   \ Transfer-Funktion
      MINT          0 LDC   OUTBYTE   \ Message-Lnge
      SP LDL  -8 ADC  SP STL
      0 LDC  SP LDL  0 STNL
      0 LDL  SP LDL  1 STNL
      SP LDL  4 ADC
      MINT  16 ADC  1 LDC  IN         \ col von Link auf Stack
      SP LDL
      MINT  16 ADC  1 LDC  IN         \ row von Link auf Stack
      NEXT END-CODE
CODE (FRAME) ( frame1 frame2 -- )     \ Cursor-Format festlegen
      MINT          5 LDC   OUTBYTE   \ Transfer-Funktion
      MINT          2 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTBYTE   \ Obere  Linie frame1 vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Untere Linie frame2 vom Stack
      SP LDL  8 ADC  SP STL  NEXT END-CODE


CR .( Interface, Terminal-Eingabe und -Ausgabe ber Host mit MSDOS )

HEX
CODE INBYTE   ( code -- c )           \ Eingabe eines Bytes vom Host
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Transfer-Code von Stack zu Link
      MINT          0 LDC   OUTBYTE   \ Message-Lnge
       0 LDC SP LDL 0 STNL            \ Byte-Blende
      SP LDL  MINT 10 ADC  1 LDC  IN  \ Byte c von Link auf Stack
      NEXT END-CODE
CODE INBTBUF  ( -- c )  \ Eingabe eines Bytes vom SERVER-Puffer TFB 80 +
      MINT   12 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT          0 LDC   OUTBYTE   \ Message-Lnge
      SP LDL -4 ADC  SP STL           \ Platz machen
       0 LDC SP LDL 0 STNL            \ Byte-Blende
      SP LDL  MINT 10 ADC  1 LDC  IN  \ Byte c von Link auf Stack
      NEXT END-CODE
CODE INDOUBLE ( code -- cc ) \ Eingabe eines Worts (Doppelbyte) vom Host
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Transfer-Code von Stack zu Link
      MINT          0 LDC   OUTBYTE   \ Message-Lnge
       0 LDC SP LDL 0 STNL            \ Doppelbyte-Blende
      SP LDL  MINT 10 ADC  2 LDC  IN  \ Doppelbyte cc von Link auf Stack
      NEXT END-CODE
CODE INDBBUF ( -- cc )
      MINT   10 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT    0 LDC  OUTBYTE          \ Message-Lnge
      SP LDL -4 ADC  SP STL           \ Platz machen
       0 LDC SP LDL  0 STNL           \ Doppelbyte-Blende
      SP LDL  MINT  10 ADC  2 LDC IN  \ Doppelbyte cc von Link auf Stack
      NEXT END-CODE
      \ Eingabe eines Host-Worts (Doppelbyte) vom SERVER-Puffer TFB 80 +
CODE INWORD   ( code -- n ) \ Eingabe eines TWortes (4 Bytes, "little-endian")
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Transfer-Code von Stack zu Link
      MINT          0 LDC   OUTBYTE   \ Message-Lnge
      SP LDL  MINT 10 ADC  4 LDC  IN  \ TWort n von Link auf Stack
      NEXT END-CODE
CODE INWDBUF ( -- n )
      MINT   14 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT    0 LDC  OUTBYTE          \ Message-Lnge
      SP LDL -4 ADC  SP STL           \ Platz machen
      SP LDL  MINT  10 ADC  4 LDC IN  \ TWort n von Link auf Stack
      NEXT END-CODE
      \ Eingabe eines TWorts ( 4 Byte ) vom SERVER-Puffer TFB 80 +
CODE IN$ ( ad -- )                    \ String vom Host mit Count nach ad
      MINT   80 LDC  OUTBYTE          \ Transfer-Code
      SP LDL  0 LDNL                  \ TAdresse
      MINT   10 ADC                   \ Eingabekanal
      1 LDC  IN                       \ Countbyte ( Stringlnge ) einholen
      SP LDL  0 LDNL  1 ADC           \ Nchste TAdresse
      MINT   10 ADC                   \ Eingabekanal
      SP LDL  0 LDNL  LB  IN          \ Reststring ( ohne Count ) einholen
      SP LDL  4 ADC   SP STL  NEXT END-CODE
      \ Die Host-Adresse muss als Langadresse im SERVER-Puffer TFB 80 + liegen
CODE OUTBYTE ( code c -- )            \ Ausgabe eines Bytes zum Host
      MINT  SP LDL  1 LDNL  OUTBYTE   \ Transfer-Code von Stack zu Link
      MINT          1 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Byte c von Stack zu Link
      SP LDL 8 ADC  SP STL  NEXT END-CODE
CODE OUTBTBUF ( c -- )  \ Ausgabe eines Bytes zum SERVER-Puffer TFB 80 +
      MINT   13 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT    1 LDC  OUTBYTE          \ Message-Lnge
      MINT  SP LDL 0 LDNL OUTBYTE     \ Byte c von Stack zu Link
      SP LDL  4 ADC  SP STL
      NEXT END-CODE
CODE OUTDBBUF ( cc -- )
      MINT   11 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT    2 LDC  OUTBYTE          \ Message-Lnge
      SP LDL   MINT   2 LDC  OUT      \ Doppelbyte cc von Stack zu Link
      SP LDL  4 ADC  SP STL           \ Stack anpassen
      NEXT END-CODE
      \ Ausgabe eines Worts (Doppelbyte) zum SERVER-Puffer TFB 80 +
CODE OUTWDBUF ( n -- )  \ Ausgabe eines TWortes zum SERVER-Puffer TFB 80 +
      MINT   15 LDC  OUTBYTE          \ Transfer-Code zum Link
      MINT    4 LDC  OUTBYTE          \ Message-Lnge
      MINT  SP LDL 0 LDNL OUTWORD     \ Wort n von Stack zu Link
      SP LDL  4 ADC  SP STL           \ Stack anpassen
      NEXT END-CODE
CODE OUT$ ( ad -- )                   \ String von ad mit Count zu Host
      MINT   81 LDC  OUTBYTE          \ Transfer-Code
      SP LDL  0 LDNL                  \ TAdresse
      MINT                            \ Ausgabekanal
      SP LDL  0 LDNL LB 1 ADC         \ Lnge des Strings mit Countbyte
                     OUT              \ String ausgeben
      SP LDL  4 ADC   SP STL          \ Stack anpassen
      NEXT END-CODE
      \ Die Host-Adresse muss als Langadresse im SERVER-Puffer TFB 80 + liegen.
: H$B! ( c -- )        \ An Host-String Byte c anhngen, ohne Count zu ndern.
      16 SWAP OUTBYTE ;               \ Wird fr PATHWAY usw. bentigt.
      \ Die Host-Adresse muss als Langadresse im SERVER-Puffer TFB 80 + liegen.
CODE (OUT) ( c fkt -- )               \ Ausgabe eines Zeichens
      MINT          1 LDC   OUTBYTE   \ Transfer-Funktion
      MINT          2 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTBYTE   \ Zeichen c vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ DOS-Funktion fkt vom Stack
      SP LDL 8 ADC  SP STL  NEXT END-CODE
\ Dies luft im Wirtssystem ber den DOS-Interrupt 21. Man htte ohne
\ groes Risiko von Inkompatibilitten auch die entsprechenden BIOS-
\ Funktionen nehmen knnen.
: DSEGMENT  ( -- bb ) 0A INDOUBLE ;   \ Holt das Host-Datensegment
                                      \ DSEGMENT war vorher bei ALLOC
: HERE-HOST ( -- bb ) 0F INDOUBLE ;
: PAD-HOST  HERE-HOST 0FF + ;
VARIABLE CP0        \ Zuletzt per KEY eingegebene Zeichen, Pufferanfang
VARIABLE CP         \ Zeiger auf Ende der zuletzt eingegebenen Zeichen
100 ALLOT-T         \ Puffer fr zuletzt eingegebene Zeichen
HERE-T CP0 !-T
HERE-T CP  !-T
: CLEAR-CHR  ( -- )  CP0 @ CP ! ;
: UPDATE-CHR ( chr -- )
      CP0 @ DUP 0FE - DUP 1- 0FF   \ from to len
      CMOVE                        \ Platz machen
      DUP 0FF - CP @ <
      IF CP 1-! THEN               \ Zeiger-Update
      C! ;                         \ Neues Zeichen chr nach CP0
: (KEY?) ( -- fl ) 0B INBYTE 0<> ; \ Test, ob am STD ( Standard Terminal
                                   \ Device ) ein Zeichen anliegt.
VARIABLE LASTKEY                   \ "Normale" Tasten:  xxh ( xx = ASCII-Code )
                                   \ Funktionstasten: xx00h
VARIABLE LASTFKEY                  \ Nur Funktionstastencode, also xxh
: (KEY)  ( -- cc )
      PAUSE                        \ Schleife fr Multitask-Betrieb einbauen ?
      0C INDOUBLE                  \ Warten auf Tastendruck, Doppelbyte holen
      LASTKEY !                    \ und aufbewahren.
      LASTKEY C@                   \ "Normale" Taste oder Funktionstaste ?
      UPDATE-CHR                   \ ASCII-Code oder 0 in Zeichenpuffer
      LASTKEY C@ 0=                \ Funktionstaste ?
      IF LASTKEY 1+ C@ DUP         \ Wenn ja, dann Funktionstasten-Code
      UPDATE-CHR                   \ in Zeichenpuffer
      LASTFKEY C! THEN             \ und getrennt aufbewahren.
      LASTKEY CC@ ;                \ Gesamtcode auf Stack.
: (PRINT) ( c -- )                 \ Zeichen c an Drucker schicken
      PAUSE 5 (OUT) #OUT 1+! ;
DECIMAL
: (CONS)  ( c -- )  6 (OUT) ;
: (CONSOLE) ( chr -- ) PAUSE (CONS) #OUT 1+! ;
: (EMIT) ( chr -- )  PRINTING @ IF DUP (PRINT) #OUT 1-! THEN (CONSOLE) ;
' (EMIT) 52 UP @-T D+ !-T  \ 52 = Byteoffset fr (EMIT) in USER-Tabelle
VARIABLE ATTRIBUTS
: (ATTRIB) ( n -- )
      ATTRIBUTS @
      IF  27 (CONS)
          91 ( ASCII [ )   (CONS)
          48 ( ASCII 0 ) + (CONS)
         109 ( ASCII m )   (CONS)
      ELSE DROP THEN ;
: ATTOFF 0 (ATTRIB) ; \ Attribute desaktivieren
: BOLD   1 (ATTRIB) ; \ Hell leuchtend
: UNDERL 4 (ATTRIB) ; \ Unterstreichen
: BLINK  5 (ATTRIB) ; \ Blinken
: INVERS 7 (ATTRIB) ; \ Inverse Bildschirmdarstellung
DEFER KEY?  DEFER KEY  DEFER CR
: PR-STAT ( -- fl ) TRUE  ( 0 15 BIOS ) ;
: CRLF   ( -- )  13 EMIT  10 EMIT  #OUT OFF  #LINE 1+! ;
: TYPE  ( ad len -- )  0 ?DO  COUNT EMIT  LOOP  DROP ;
: REPLICATE ( n chr -- )   \ Gibt n-mal das Zeichen chr aus
      SWAP 0 MAX 0 ?DO DUP EMIT LOOP DROP ;
: SPACE      ( -- )   BL EMIT ;
: SPACES     ( n -- ) BL REPLICATE ;
: BACKSPACES ( n -- ) BS REPLICATE ;
: BEEP       ( -- )   BELL EMIT ;


CR .( Transfer von Host-Langadresse nach TStack )
HEX
\ Dieses Wort wurde vorgezogen, da es hier schon bentigt wird. Die zu-
\ gehrigen Worte C@-H 2@-H C!-H !-H 2!-H  sind in TCORE.FTH zu finden.

CODE  @-H ( seg-H ad-H -- cc ) \ Doppelbyte cc von Host-Langadresse auf TStack
     MINT         27 LDC   OUTBYTE    \ Transfer-Code
     MINT          4 LDC   OUTBYTE    \ Message-Lnge
     SP LDL 4 ADC MINT 2 LDC  OUT     \ Host-Segment seg vom TStack
     SP LDL       MINT 2 LDC  OUT     \ Host-Adresse  ad vom TStack
     SP LDL  4 ADC SP STL             \ TStack anpassen
      0 LDC SP LDL 0 STNL             \ zunchst alles = 0
     SP LDL                           \ Doppelbyte cc
     MINT   10 ADC  2 LDC     IN      \ von Link zu TStack
     NEXT END-CODE


CR .( Schnittstelle  Steuercodes, systemabhngig )

DEFER CHAR1
: (CHAR1)   ( a n chr -- a n+1 )     3DUP EMIT + C! 1+ ;

VARIABLE INS     \ Zustand der Einfgetaste ( 0/-1 = berschreiben/Einfgen )
-1 INS !-T       \ Vorgabe "Einfgen"

: DEL-IN   ( ad n -- ad 0 | ad n-1 )
     INS @ 0=    \ Wenn "berschreiben", dann erst Cursor um 1 nach rechts
     IF
       DUP #TIB @ <>                  \ berhaupt noch Platz ?
       IF (CURSOR) SWAP
         DUP 40 4A @-H 1- <           \ Zeilenende ?
         IF   1+ SWAP
         ELSE DROP 0 SWAP 1+          \ Wenn ja, dann 1 Zeile weiter.
         THEN
         AT 1+                        \ TIB um 1 weiter.
       THEN
     THEN
     DUP
     IF   2DUP + DUP 1- #TIB @ 3 PICK - MOVE 1-
          (CURSOR) SWAP DUP 0>
          IF 1- SWAP ELSE DROP 40 4A @-H 1- SWAP 1- THEN AT
          (CURSOR) 2SWAP 2DUP + 2 PICK #TIB @ + SWAP
          ?DO   BL EMIT LOOP 2SWAP AT  #TIB 1-!
          (CURSOR) 2SWAP 2DUP + 2 PICK #TIB @ + SWAP
          ?DO I C@ EMIT LOOP 2SWAP AT
     ELSE BELL EMIT
     THEN ;

: BACK-UP ( n c -- 0 )
     DUP BACKSPACES DUP SPACES   BACKSPACES   0 ;
: P-IN  ( c -- )   PRINTING @ NOT PRINTING !  ;

: UPDATE-FORTHKEY ( -- ) NOOP ;          \ Vorlufig

: ?SCREEN@-OFF ( -- ) NOOP ;             \ Vorlufig, siehe auch QUIT.

: CR-IN ( m a n c -- m a m )
      ?SCREEN@-OFF                       \ Zeichen-Einsammeln ausschalten.
      DUP DUP #TIB @ MAX SWAP - (CURSOR) \ Restliche Eingaben modulo c/l-bios.
      >R + 40 4A @-H /MOD R> + AT        \ Cursor Spalte/Zeile anpassen.
      #TIB @ MAX SPAN ! OVER             \ Gesamtzahl bisheriger Eingaben.
      UPDATE-FORTHKEY BL EMIT ;          \ BL ausgeben, wie bisher.

: DARK  ( -- )
      NOOP  #LINE OFF  #OUT OFF ;
\ Wird initialisiert durch  ' (MODE) IS DARK
\ DARK war ursprnglich weiter unten vor MODE.

DEFER BYE
: >HOST ( -- )
     BYE RESET ;
VARIABLE CC   CREATE CC-FORTH
]  NOOP    NOOP  NOOP  NOOP  NOOP  NOOP    NOOP  NOOP
   DEL-IN  NOOP  NOOP  NOOP  NOOP  CR-IN   NOOP  NOOP
   P-IN    NOOP  NOOP  NOOP  NOOP  BACK-UP NOOP  NOOP
   BACK-UP NOOP  NOOP  BYE   NOOP  NOOP    NOOP  NOOP  [


CR .( Eaker-Case )
DECIMAL

: ALLOT     ( n -- )  DP +!          ;                 \ vorgezogen
: ,         ( n -- )  HERE ! 4 ALLOT ;                 \ vorgezogen
: >MARK     ( -- ad ) HERE 0 ,       ;                 \ vorgezogen
: >RESOLVE  ( ad -- ) HERE SWAP !    ;                 \ vorgezogen
: COMPILE   ( -- ) R> DUP 4+ >R  @ , ;                 \ vorgezogen
: IMMEDIATE ( -- ) 64 ( Precedence bit ) LAST @ CSET ; \ vorgezogen
: !CSP      ( -- ) SP@ CSP ! ;  \ Vorher vor ?CSP      \ vorgezogen

: CASE    CSP @ !CSP                                   ; IMMEDIATE
: OF      COMPILE OVER COMPILE = COMPILE ?BRANCH >MARK
          COMPILE DROP                                 ; IMMEDIATE
: ENDOF   COMPILE BRANCH >MARK SWAP >RESOLVE           ; IMMEDIATE
: ENDCASE COMPILE DROP
          BEGIN  SP@ CSP @ <>
          WHILE  >RESOLVE
          REPEAT CSP !                                 ; IMMEDIATE


CR .( Schnittstelle  Eingabe-Ausgabe )
HEX

VARIABLE #COL0        \ Spaltennummer des ersten Eingabezeichens.

CODE C/L       \ maximale Eingabelnge ( ber TIB )
      0FF LDC 1PUSH END-CODE          \  = 0FF CONSTANT C/L

: TIB   ( -- ad )  'TIB @ ;

: HOTKEYS NOOP ;                      \ Vorlufig. Wird auf (HOTKEYS) gelegt.

: EXPECT   ( ad len -- )
     #TIB OFF (CURSOR) DROP #COL0 !
     DUP SPAN ! SWAP 0 ( len ad 0 )
     BEGIN  2 PICK OVER - ( len ad #so-far #left )
     OVER #TIB @ MAX #TIB !
     WHILE
       KEY
       HOTKEYS                        \ Siehe TCORE.FTH
       0FF AND DUP BL <
       IF
         DUP 1B = IF >R 2DROP DROP R> THEN  4* CC @ + PERFORM
       ELSE
         INS @
         IF
            #TIB @ 1+ C/L <
            IF #TIB 1+! OVER DUP 4 PICK + DUP 1+
               #TIB @ 3 PICK - MOVE DROP CHAR1
               (CURSOR)
               3 PICK 3 PICK + 4 PICK #TIB @ + SWAP
               ?DO  (CURSOR) NIP I C@ EMIT
                    (CURSOR) SWAP 0= -ROT = AND
                    IF 1- THEN
               LOOP
               AT
            THEN
         ELSE
            CHAR1
         THEN
       THEN
     DUP #TIB @ MAX #TIB !
     REPEAT
     #TIB OFF 2DROP DROP ;

: QUERY ( -- ) TIB C/L EXPECT  SPAN @ #TIB !  >IN OFF ;

CR .( Disketten-Ein- und -Ausgabe )
HEX

CODE (OPEN) ( pathname access -- hndl fl )
      MINT         17 LDC   OUTBYTE   \ Transfer-Code
      MINT          5 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTWORD   \ Adresscode pathname vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Zugangskennung access vom Stack
       0 LDC SP LDL 1 STNL
       0 LDC SP LDL 0 STNL
      SP LDL  4 ADC
      MINT  10 ADC  1 LDC   IN        \ hndl von Link zu Stack
      SP LDL
      MINT  10 ADC  1 LDC   IN        \ Error-Flag fl von Link zu  Stack
      NEXT END-CODE
\ access = 0 : Dateizugang nur zum Lesen
\ access = 1 : Dateizugang nur zum Schreiben
\ access = 2 : Dateizugang zum Lesen und Schreiben
\ Der Zugangscode muss mit dem Datei-Attribut bereinstimmen
CODE (CLOSE) ( hndl -- )
      MINT         0D LDC   OUTBYTE   \ Transfer-Funktion
      MINT          1 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Dateinummer hndl vom Stack
      SP LDL  4 ADC  SP STL           \ Stack korrigieren
      NEXT END-CODE
CODE GET-HOST ( seg ad len hndl -- len' fl )
      MINT         1A LDC   OUTBYTE   \ Transfer-Code
      MINT          7 LDC   OUTBYTE   \ Message-Lnge
      SP LDL 0C ADC MINT 2 LDC  OUT   \ Host-Segment seg vom Stack
      SP LDL  8 ADC MINT 2 LDC  OUT   \ Host-Offset buf vom Stack
      SP LDL  4 ADC MINT 2 LDC  OUT   \ Anzahl zu lesender Bytes len vom Stack
      SP LDL        MINT 1 LDC  OUT   \ Dateikennung hndl vom Stack
      SP LDL 8 ADC SP STL
       0 LDC SP LDL 1 STNL
       0 LDC SP LDL 0 STNL
      SP LDL 4 ADC
      MINT  10 ADC  2 LDC   IN        \ Tatschlich gelesene Bytezahl len'
      SP LDL                          \ von Link zu Stack
      MINT  10 ADC  1 LDC   IN        \ Error-Flag fl von Link zu  Stack
      NEXT END-CODE
      \ Die Host-Adresse ist in der abgesetzten Form als Segment,Adresse
      \ einzugeben. Das Einlesen beginnt dort, wo der Dateizeiger gerade
      \ steht. Der Zeiger wird mit jedem Lesen von n Bytes um n Positionen
      \ weitergerckt. Setzen ohne Lesevorgang siehe (SEEK) .
      \ Das obige GET-HOST gestattet es, auf das (GET) im Host durchzugreifen.
      \ seg ad : Segment und Adresse  vom Anfang  des  Text-Puffers.  Wenn der
      \          Puffer im Datensegment des Host-FORTH-Systems liegt,  ist fr
      \          seg DSEGMENT zu verwenden.
      \ len :    Anzahl der einzulesenden Bytes.
      \ hndl :   Dateikennziffer.
      \ len' :   Tatschlich eingelesene Bytezahl.
      \ err :    Mit ?DOS-ERR ablesbarer Fehlercode.
CODE (GET) ( ad1 ad2 -- )             \ Bis zu 64K von Host-ESEGMENT
      MINT   83 LDC         OUTBYTE   \ Transfer-Funktion
      SP LDL  1 LDNL                  \ ad1
      SP LDL  0 LDNL                  \ ad2
      SUB  AREG STL                   \ Blocklnge
      SP LDL  1 LDNL                  \ ad1
      MINT 10 ADC AREG LDL  IN        \ RAM-Block von ad1 nach Host
      SP LDL 8 ADC  SP STL  NEXT END-CODE
CODE PUT-HOST ( seg ad len hndl -- len' fl )
      MINT         1B LDC   OUTBYTE   \ Transfer-Code
      MINT          7 LDC   OUTBYTE   \ Message-Lnge
      SP LDL 0C ADC MINT 2 LDC  OUT   \ Host-Segment seg vom Stack
      SP LDL  8 ADC MINT 2 LDC  OUT   \ Host-Offset buf vom Stack
      SP LDL  4 ADC MINT 2 LDC  OUT   \ Anzahl zu schreibender
                                      \ Bytes len vom Stack
      SP LDL        MINT 1 LDC  OUT   \ Dateikennung hndl vom Stack
      SP LDL 8 ADC SP STL
       0 LDC SP LDL 1 STNL
       0 LDC SP LDL 0 STNL
      SP LDL 4 ADC
      MINT  10 ADC  2 LDC   IN        \ Tatschlich geschriebene Bytezahl len'
      SP LDL                          \ von Link zu Stack
      MINT  10 ADC  1 LDC   IN        \ Error-Flag fl von Link zu  Stack
      NEXT END-CODE
      \ Die Host-Adresse ist in der abgesetzten Form als Segment,Adresse
      \ einzugeben. Das Schreiben in die Datei beginnt dort, wo der Datei-
      \ zeiger gerade steht. Der Zeiger wird mit jedem Schreiben von n
      \ Bytes um n Positionen weitergerckt. Setzen ohne Schreibvorgang
      \ siehe (SEEK).
      \ Das obige PUT-HOST gestattet es, auf das (PUT) im Host durchzugreifen.
      \ seg ad : Segment und Adresse  vom Anfang  des  Text-Puffers.  Wenn der
      \          Puffer im Datensegment des Host-FORTH-Systems liegt,  ist fr
      \          seg DSEGMENT zu verwenden.
      \ len :    Anzahl der in die Datei zu schreibenden Bytes.
      \ hndl :   Dateikennziffer.
      \ len' :   Tatschlich geschriebene Bytezahl.
      \ err :    Mit ?DOS-ERR ablesbarer Fehlercode.
CODE (PUT) ( ad1 ad2 -- )             \ Bis zu 64K nach Host-DSEGMENT+1000h
      MINT   84 LDC         OUTBYTE   \ Transfer-Code
      SP LDL  0 LDNL                  \ ad1
      SP LDL  1 LDNL                  \ ad2
      SUB  AREG STL                   \ Blocklnge ad2-ad1
      AREG LDLP MINT  2 LDC OUT       \ Lnge zu Link
      SP LDL  1 LDNL                  \ ad1
      MINT AREG LDL         OUT       \ RAM-Block von ad1 zu Link
      SP LDL 8 ADC  SP STL  NEXT END-CODE
CODE (CREATE) ( pathname att -- hndl fl )
      MINT         18 LDC   OUTBYTE   \ Transfer-Code
      MINT          5 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTWORD   \ Adresscode ad vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Attribut att vom Stack
       0 LDC SP LDL 1 STNL
       0 LDC SP LDL 0 STNL
      SP LDL  4 ADC
      MINT  10 ADC  1 LDC   IN        \ hndl von Link zu Stack
      SP LDL
      MINT  10 ADC  1 LDC   IN        \ Error-Flag fl von Link zu  Stack
      NEXT END-CODE
CODE (SEEK) ( len hndl way -- pos fl )
      MINT         1C LDC   OUTBYTE   \ Transfer-Code
      MINT          6 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  2 LDNL  OUTWORD   \ Verschiebungbytezahl len vom Stack
      MINT  SP LDL  1 LDNL  OUTBYTE   \ Dateikennziffer hndl vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Bewegungsart way vom Stack
      SP LDL 4 ADC SP STL
       0 LDC SP LDL 0 STNL
      SP LDL 4 ADC
      MINT  10 ADC  4 LDC   IN        \ Zeigerposition pos von Link zu Stack
      SP LDL
      MINT  10 ADC  1 LDC   IN        \ Error-Flag fl von Link zu  Stack
      NEXT END-CODE
      \ (SEEK) ist diejenige DOS-Funktion, die den Zeiger einer Datei setzt.
      \ Damit wird ein direkter gezielter Dateizugriff mglich.  Da eine Da-
      \ tei lnger als 64K sein kann,  werden 2len und 2pos  fr das Hostsy-
      \ stem  als vorzeichenlose 32-Bit-Zahlen  ausgelegt.  Mit way wird die
      \ Bewegungsart festgelegt: 0 = von Dateibeginn aus, 1 = von der augen-
      \ blicklichen Zeigerstellung,  2  =  vom Dateiende aus,  immer in Vor-
      \ wrtsrichtung. Mit  way = 2 und 2len = 0  kann die Lnge einer Datei
      \ bestimmt werden.  2pos ist die neue Position  des Dateizeigers,  als
      \ Offset vom Dateianfang an gerechnet.

\ : (REN) liegt jetzt in TCORE.FTH

CODE (SEARCH0) ( att -- fl )
      MINT         1E LDC   OUTBYTE   \ Transfer-Code von Stack zu Link
      MINT          1 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Datei-Attribut att zum Link
      0 LDC SP LDL 0 STNL             \ Byte-Blende
      SP LDL  MINT 10 ADC  1 LDC IN   \ Errorbyte fl von Link auf Stack
      NEXT END-CODE        \ In HERE-HOST muss die Datei, nach der
                           \ gesucht wird, als ASCII0-String liegen.
: (SEARCH) ( -- fl ) 1F INBYTE ;
CODE (FREE) ( drv -- b/sec #cluster-tot #cluster sec/cluster )
      MINT         1D LDC   OUTBYTE   \ Transfer-Code
      MINT          2 LDC   OUTBYTE   \ Message-Lnge
      SP LDL  MINT  2 LDC   OUT       \ Laufwerk drv vom Stack
      SP LDL -0C ADC SP STL           \ Platz machen
      SP LDL
      MINT   10 ADC 10 LDC  IN        \ b/sec usw. von Link auf Stack
      NEXT END-CODE
      \ Achtung: 0 = momentan eingeschaltetes Laufwerk, 1 = A: , 2 = B: usw.,
      \ im Gegensatz zu SELECT, wo 0 = A: , 1 = B: usw.
      \ Ich habe (FREE) genenber dem Hostsystem Turbo-FORTH von JEDI
      \ abgendert, um alle von DOS gelieferten Informationen auszunutzen.
      \ #cluster ist die verfgbare Cluster-Zahl, #cluster-tot ist die
      \ Gesamtclusterzahl des betreffenden Speichermediums.
      \ b/sec = Bytes pro Sektor.
      \ sec/cluster = Sektoren pro Cluster, falls kein Fehler, sonst = TRUE

\ CODE (PROGRAM) ( ad-filename ad-param mode -- fl ) jetzt in TCORE.FTH
\ DSEGMENT jetzt bei OUT$
\ CODE ALLOC     ( #p -- bloc )                      jetzt in TCORE.FTH

CODE (GETLINE) ( ad hndl -- fl )
      MINT         19 LDC   OUTBYTE   \ Transfer-Code
      MINT          5 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTWORD   \ Adresscode ad vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Datei-Kennziffer hndl vom Stack
      SP LDL 4 ADC  SP STL
       0 LDC SP LDL 0 STNL
      SP LDL  MINT 10 ADC  1 LDC IN   \ Flag fl von Link auf Stack
      NEXT END-CODE
      \ (GETLINE) liest eine ganze Zeile, die mit <CR> endet, aus einer Datei.
      \ Der erzeugte String ist implizit:  Das erste Byte  enthlt die Zeilen-
      \ lnge.  Wenn ein solcher String 255 Zeichen berschreitet,  werden nur
      \ die erten 255 Zeichen akzeptiert.  Die Datei wird dann als beendet be-
      \ trachtet, da angenommen wird,  dass es sich dann nicht um eine Textda-
      \ tei handelt. Alle Steuerzeichen werden in SPACE umgewandelt.
CODE BDOS ( ad fkt -- err )
      MINT          2 LDC   OUTBYTE   \ Transfer-Code
      MINT          5 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  1 LDNL  OUTWORD   \ Adresscode ad vom Stack
      MINT  SP LDL  0 LDNL  OUTBYTE   \ DOS-Funktion fkt vom Stack
      SP LDL 4 ADC  SP STL
       0 LDC SP LDL 0 STNL
      SP LDL  MINT 10 ADC  1 LDC IN   \ Fehlercode err von Link auf Stack
      NEXT END-CODE
                 \ Fr SELECT (fkt=14), SET-DMA (fkt=26), MKDIR (fkt=57),
                 \     RMDIR  (fkt=58), CHDIR   (fkt=59), DEL   (fkt=65).

DECIMAL
CR .( DOS-Fehlermeldungen )

: ?DOS-ERR ( err -- )
     ?DUP IF HERE COUNT 2DUP UPPER TYPE
      1 OVER = ABORT" Ungltige DOS-Funktionsnummer"
      2 OVER = ABORT" Datei nicht gefunden"
      3 OVER = ABORT" Pfad nicht gefunden"
      4 OVER = ABORT" Zu viele offene Dateien"
      5 OVER = ABORT" Zugriff nicht erlaubt"
      6 OVER = ABORT" Ungltige Dateinummer"
      7 OVER = ABORT" Speicherkontrollblock zerstrt"
      8 OVER = ABORT" Zu wenig Speicher"
      9 OVER = ABORT" Ungltige Speicherkontrollblockadresse"
     10 OVER = ABORT" Ungltige Umgebung"
     11 OVER = ABORT" Ungltiges Format"
     12 OVER = ABORT" Ungltiger Zugriffscode"
     13 OVER = ABORT" Ungltige Daten"
     15 OVER = ABORT" Ungltiges Laufwerk"
     16 OVER = ABORT" Versuch, aktuelles Verzeichnis zu lschen"
     17 OVER = ABORT" Falsche Gerte-Einheit"
     18 OVER = ABORT" Keine weiteren Dateien vorhanden"
               ABORT" DOS-Fehler"
     THEN ;

CR .( Verwaltung der Disketten-Ein- und -Ausgabe)
HEX

: SELECT  ( drv -- )  0E  BDOS  DROP ;
DECIMAL

\ Laufwerk-Umschaltungen A: bis K: jetzt in TCORE.FTH
\ : A: 0 SELECT ;  : D: 3 SELECT ;  : G:  6 SELECT ;  : J:  9 SELECT ;
\ : B: 1 SELECT ;  : E: 4 SELECT ;  : H:  7 SELECT ;  : K: 10 SELECT ;
\ : C: 2 SELECT ;  : F: 5 SELECT ;  : I:  8 SELECT ;
8 CONSTANT FILES               \ Maximal mgliche Zahl offener Dateien
: #FILES ( -- n ) 7 INBYTE ;   \ Zahl der bereits geffneten Dateien
: ?OPEN  ( -- )
     #FILES FILES = ABORT" Zu viele Dateien fr TURBO-Forth offen" ;
VARIABLE EOF?
: EOF EOF? ON ; \ erlaubt ein vorzeitiges Ende der laufenden Datei
CODE C/PATH     \ maximale Lnge eines Datei&Pfad-Namens
      64 LDC  1PUSH  END-CODE
CODE LBUF       \ Gesamtlnge eines Zeilenpuffers = 322d
      255 ( C/L ) 64 ( C/PATH ) D+ 3 D+ LDC 1PUSH END-CODE
HEX
: BUFFER   ( -- ad )  \ Adresse des Zeilenpuffers der aktuellen Datei
      EOS @ LBUF HANDLE @ 1+ * - ;
      \ Der Puffer ist jetzt am Systemende orientiert.
      \ SP0 schliet sich ( nach unten zu ) an.
: LINE#    ( -- ad )  \ Adresse der Nummer der aktuellen Zeile
      BUFFER 1+ C/L + ;
: PATHNAME ( -- ad )  \ Adresse des Namens der aktuellen Datei
      LINE# 2+ ;
      \ Die Zeilenpuffer  werden den Dateien  im Speicher  von
      \ oben nach unten  zugeordnet.  Sie beginnen mit der ef-
      \ fektiven Lnge,  der Zeilennummer  und dem Dateinamen.
      \ Ich habe mich hier an der Organisation von Turbo-Forth
      \ im Hostsystem, in welchem der Server programmiert ist,
      \ orientiert.  Insbesondere wurden  fr die Zeilennummer
      \ nur zwei Bytes reserviert.  Das ist bei Verwendung von
      \ LINE# zu beachten: CC@ und CC! statt @ und !
      \ Der Puffer ( BUFFER ) sieht wie folgt aus:
      \   1 Byte Lnge der eingelesenen Zeile
      \ 255 Byte fr einzulesende Zeile
      \   2 Byte Nummer der eingelesenen Zeile
      \  64 Byte Name der Datei


DECIMAL
CR .( Zahleneingabe )

ASSEMBLER
LABEL FAIL  SP LDL  0 STNL  NEXT END-CODE
CODE DIGIT  ( chr base -- n true )    \ , falls Zahl; n = Zahlwert
            ( chr base -- chr false ) \ , falls keine Zahl
      SP LDL  0 LDNL  BREG STL        \ Basis nach BREG
      SP LDL  1 LDNL
      48 LDC  SUB  AREG STL           \ chr-ASCII(0) nach AREG
      AREG LDL  -1 LDC  GT            \ Sprung, falls chr < ASCII 0
      FAIL HERE-T 2 D+ D- CJ
      AREG LDL   9 LDC  GT            \ 57 < ASCII(chr) ?
      1IF
        AREG LDL  16 LDC  GT
        FAIL HERE-T 2 D+ D- CJ        \ Sprung, falls ASCII(chr) < 65 ;
        AREG LDL
        7 LDC  SUB  AREG STL          \ sonst chr-ASCII(A) nach AREG
      THEN
      BREG LDL  AREG LDL  GT
      FAIL HERE-T 2 D+ D- CJ          \ Sprung, falls > Basis
      AREG LDL  SP LDL  1 STNL
        -1 LDC  SP LDL  0 STNL  NEXT END-CODE
: DOUBLE?   ( -- fl )  DPL @ 1+ 0<> ;
: CONVERT   ( +d1 ad1 -- +d2 ad2 )
      BEGIN  1+  DUP >R  C@  BASE @  DIGIT
      WHILE  SWAP ROT BASE @ UM* NIP -ROT BASE @ UM* D+
             DOUBLE?  IF DPL 1+! THEN  R>
      REPEAT DROP R> ;
: (NUMBER?) ( ad -- d fl )
      0 0  ROT  DUP 1+  C@  ASCII -  =  DUP  >R  -  -1 DPL !
      BEGIN   CONVERT  DUP C@  ASCII , ASCII / BETWEEN
      WHILE   0 DPL !
      REPEAT  -ROT  R> IF  DNEGATE  THEN   ROT C@ BL =  ;
: NUMBER?   ( ad -- d fl )
      FALSE OVER COUNT BOUNDS
      ?DO I C@ BASE @ DIGIT NIP IF DROP TRUE LEAVE THEN LOOP
      IF (NUMBER?) ELSE DROP 0 0 FALSE THEN  ;
CODE 'WORD  ( -- ad )                 \ = HERE
      UP LDC  0 LDNL  5 LDNL          \ 5 = Wortoffset von DP in USER-Tabelle
      1PUSH  END-CODE
: ?MISSING  ( fl -- )                 \ war vorher bei CRASH
    IF  'WORD  COUNT SPACE INVERS TYPE ATTOFF TRUE
        ABORT"  ist ein unbekanntes Wort"
    THEN ;
: (NUMBER)  ( ad -- d )  NUMBER? NOT  ?MISSING  ;
DEFER NUMBER

DECIMAL
CR .( Zahlenausgabe )

: HOLD  ( chr -- )       HLD 1-! HLD @ C!       ;
: <#    ( -- )           PAD HLD !              ;
: #>    ( d -- ad len )  2DROP HLD @ PAD OVER - ;
: SIGN  ( n -- )         0< IF  45 ( ASCII - ) HOLD  THEN  ;
: #     ( ud1 -- ud2 )   BASE @ MU/MOD ROT 9 OVER <
                         IF 7 + THEN 48 ( ASCII 0 ) + HOLD ;
: #S      ( -- )         BEGIN  #  2DUP  OR  0=  UNTIL     ;
: HEX     ( -- ) 16 BASE ! ;
: DECIMAL ( -- ) 10 BASE ! ;
: OCTAL   ( -- )  8 BASE ! ;
: (D.)  ( d -- ad len )  OVER SWAP DABS <# #S ROT SIGN #> ;  \ siehe (U.)
: D.    ( d -- )         (D.)  TYPE SPACE ;
: D.R   ( d len -- )     >R  (D.) R> OVER - SPACES TYPE ;
\ : .R    ( n len -- )     >R (.) R> OVER - SPACES TYPE ;
: .R    ( n len -- )     >R S>D R> D.R ;     \ gendert 22.4.95
: (U.)  ( u -- ad len )  0 SWAP <# #S #> ;   \ SWAP, da "Little-Endian"
: U.    ( u -- )         (U.) TYPE SPACE ;
\ : U.R   ( u len -- )     >R (U.) R> OVER - SPACES TYPE ;
: U.R   ( u len -- )     0 -ROT D.R ;        \ gendert 22.4.95
: (.)   ( n -- ad len )  DUP ABS 0 SWAP <# #S ROT SIGN #> ;  \ siehe (U.)
: .     ( n -- )         (.) TYPE SPACE ;
: H.    ( n -- ) \ Zeigt TOS in Hexadezimal an, ohne BASE zu verndern
                         BASE @   HEX    SWAP U. BASE ! ;
: B.    ( n -- ) \ Zeigt TOS in Binr       an, ohne BASE zu verndern
                         BASE @ 2 BASE ! SWAP U. BASE ! ;
: ?     ( ad -- )        @ . ;
: (UD.) ( ud -- ad len ) <# #S #> ;
: UD.   ( ud -- )        (UD.) TYPE SPACE ;
: UD.R  ( ud len -- )    >R (UD.) R> OVER - SPACES TYPE ;

DECIMAL
CR .( Dictionary durchsuchen )

CODE SKIP ( ad len chr -- ad' len' )  \ In String ad len alle Zeichen
      SP LDL  2 LDNL  AREG STL  \ ad    = chr berspringen. ad' len'
      SP LDL  1 LDNL  BREG STL  \ len   ist dann der Reststring
      SP LDL  0 LDNL  CREG STL  \ chr
                      BREG LDL  0<>
      2IF
        BEGIN
          AREG LDL      LB  CREG LDL  SUB  0 EQC  0 EQC
                            BREG LDL       0 EQC  OR
          AREG LDL  SP LDL    2 STNL
          BREG LDL  SP LDL    1 STNL
          AREG LDL   1 ADC  AREG STL
          BREG LDL  -1 ADC  BREG STL
        UNTIL
      THEN  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE SCAN ( ad len chr -- ad' len' )  \ In String ad len alle Zeichen
      SP LDL  2 LDNL  AREG STL  \ ad    <> chr berspringen. ad' len'
      SP LDL  1 LDNL  BREG STL  \ len   ist dann der Reststring
      SP LDL  0 LDNL  CREG STL  \ chr
                      BREG LDL  0<>
      2IF
        BEGIN
          AREG LDL      LB  CREG LDL  SUB  0 EQC
                            BREG LDL       0 EQC  OR
          AREG LDL  SP LDL    2 STNL
          BREG LDL  SP LDL    1 STNL
          AREG LDL   1 ADC  AREG STL
          BREG LDL  -1 ADC  BREG STL
        UNTIL
      THEN  SP LDL  4 ADC  SP STL  NEXT END-CODE
CODE /STRING  ( ad len pos -- ad' len' )
      SP LDL  2 LDNL  AREG STL
      SP LDL  1 LDNL  BREG STL
      SP LDL  0 LDNL  CREG STL
      CREG LDL  BREG LDL  GT  1IF  BREG LDL  CREG STL  THEN
      AREG LDL  CREG LDL  ADD  SP LDL  2 STNL
      BREG LDL  CREG LDL  SUB  SP LDL  1 STNL
      SP LDL  4 ADC  SP STL  NEXT END-CODE
: PLACE      ( ad len to -- )  3DUP 1+ SWAP MOVE C! DROP ;
DEFER SOURCE
: PARSE-WORD ( chr -- ad len )
      >R  SOURCE TUCK  >IN @ /STRING  R@ SKIP  OVER SWAP R> SCAN
      >R OVER -  ROT R>  DUP 0<> + - >IN !  ;
: PARSE      ( chr -- ad len )
      >R   SOURCE >IN @ /STRING   OVER SWAP R> SCAN
      >R OVER -  DUP R>  0<> -  >IN +!  ;
\ : 'WORD    ( -- ad )   HERE  ;
\ CODE 'WORD   ( -- ad )              \ = HERE  \ jetzt bei (NUMBER)
: WORD       ( chr -- ad )
      PARSE-WORD  'WORD PLACE
      'WORD DUP COUNT + BL SWAP C!   ( Blank am Ende anfgen ) ;
: >TYPE      ( adr len -- )  TUCK PAD SWAP CMOVE  PAD SWAP TYPE  ;
: .(   ( -- )
     ASCII ) PARSE  ['] EMIT 4+ DUP @ SWAP >R >R
     ['] (EMIT) IS EMIT   >TYPE  R> R> ! ; IMMEDIATE
: (      ( -- )   ASCII ) PARSE 2DROP  ; IMMEDIATE

DECIMAL
CR .( Worte zur Einrichtung des Dictionarys )

: EVEN ( ad -- ad' ) 3 + -4 AND ;     \ EVEN war vorher bei C,
     \ ad' = ad auf nchstgelegenen Adresswert mit Byteselektor = 0
CODE TRAVERSE ( ad direction -- ad' )
      SP LDL  0 LDNL  SP LDL  1 LDNL  ADD  AREG STL
      BEGIN  AREG LDL  LB  128 LDC  AND  0= 1WHILE
      AREG LDL  SP LDL  0 LDNL  ADD  AREG STL  REPEAT
      AREG LDL  SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE
: DONE?    ( n -- fl )  STATE @ <> END? @ OR END? OFF ;
: FORTH-83 ( -- )       FORTH DEFINITIONS CAPS OFF    ;
: N>LINK   ( nfa -- lfa ) 4-           ;
: L>NAME   ( lfa -- nfa ) 4+           ;
: BODY>    ( pfa -- cfa ) 4-           ;
DEFER NAME>                              \ nderung 7.9.95
: NAME>-ENG ( nfa -- cfa ) 1 TRAVERSE 1+
                                      1+ \ Extrabyte bercksichtigen
                            EVEN       ; \ nderung 7.9.95
: LINK>    ( lfa -- cfa ) L>NAME NAME> ;
: >BODY    ( cfa -- pfa ) 4+           ;
DEFER >NAME                              \ nderung 7.9.95
: >NAME-ENG ( cfa -- nfa )               \ nderung 7.9.95
      BEGIN 1- DUP C@ 128 AND UNTIL
                           -1 TRAVERSE ;
: >LINK    ( cfa -- lfa ) >NAME N>LINK ;
: >VIEW    ( cfa -- vfa ) >LINK 4-     ;
CODE HASH ( str-ad voc-ptr -- thread )  SP LDL  1 LDNL
      1 ADC      LB   3 LDC    AND   2 LDC  SHL  SP LDL  0 LDNL  ADD
     SP LDL  1 STNL  SP LDL  4 ADC  SP STL  NEXT END-CODE

CODE (FIND)-ENG ( ad lfa -- cfa flag | ad false )
      SP LDL  0 LDNL  DREG STL      \ lfa
      DREG LDL  0=
      1IF  0 LDC  SP LDL  0 STNL  NEXT THEN
      BEGIN
        DREG LDL  BREG STL            \ String-Arbeitsspeicher
        BREG LDL 4 ADC BREG STL       \ nach nfa gehen
        SP LDL  1 LDNL  CREG STL      \ Stringadresse ( ursprnglich DI )
        BREG LDL  LB  CREG LDL  LB
        XOR  63 LDC  AND  AREG STL    \ Vergleichs-Arbeitsspeicher
        AREG LDL  0=
        2IF
          BEGIN
            BREG LDL 1 ADC  BREG STL
            CREG LDL 1 ADC  CREG STL
            BREG LDL  LB  CREG LDL  LB
            XOR  AREG STL
            AREG LDL  0<>
          UNTIL
          127 LDC  AREG LDL  AND  AREG STL  AREG LDL  0=
          2IF
            BREG LDL  2 ADC  SP LDL  1 STNL     \ Von 1 ADC auf 2 ADC gendert,
            DREG LDL  BREG STL                  \ um das Extrabyte zu berck-
            BREG LDL  4 ADC  BREG STL           \ sichtigen.     -     7.9.95
            BREG LDL  LB  64 LDC  AND  AREG STL
            AREG LDL  0<>
            1IF
               1 LDC  AREG STL
            1ELSE
              -1 LDC  AREG STL
            THEN
            AREG LDL  SP LDL  0 STNL
            4 LDC  SP LDL  1 LDNL  3 LDC  AND  SUB  3 LDC  AND
            SP LDL  1 LDNL   ADD  SP LDL  1 STNL  NEXT
          THEN
        THEN
        DREG LDL  0 LDNL  DREG STL
        DREG LDL  0=
      UNTIL
      0 LDC  SP LDL  0 STNL  NEXT END-CODE
\ (FIND)-ENG war ursprnglich als (FIND) im System  und arbeitete in der
\ Testphase von 1992 bis 1995  ausgezeichnet.  Diese Version  testet das
\ hchste Bit des letzten Zeichens im Namensfeld auf 1.  In einem System
\ ohne diese 1  arbeitet  (FIND)-ENG  nicht.  Die hinzugekommene Version
\ (FIND)-GER  ( siehe unten )  kommt  ohne  den Test auf die 1 aus.  Sie
\ lsst sich aber in einem System mit einer 1 im hchsten Bit des letz-
\ ten Zeichens, nicht verwenden,  da die 1 das Zeichen verflschen wrde.
\ Zum Umschalten wird eine Zwischenversion ntig, (FIND)-XXX, die weiter
\ unten zu finden ist.

DEFER (FIND)
            \ (FIND) wird ber ENGLISH oder GERMAN ( siehe TCORE.FTH )
            \ nach (FIND)-ENG oder (FIND)-GER umgeschaltet.

CODE #THREADS  4 LDC  1PUSH END-CODE  \ 4 CONSTANT #THREADS
: FIND ( ad -- cfa fl | ad false )
     DUP C@
     IF PRIOR OFF FALSE #VOCS 0
          DO DROP CONTEXT I 4* + @ DUP
           IF DUP PRIOR @ OVER PRIOR ! =
            IF DROP FALSE
            ELSE OVER SWAP HASH @ (FIND) DUP ?LEAVE
            THEN
           THEN
          LOOP
     ELSE DROP END? ON ['] NOOP 1
     THEN  ;
: ?UPPERCASE ( ad -- ad ) CAPS @ IF DUP COUNT UPPER THEN ;
: DEFINED ( -- here 0 | cfa [ -1 | 1 ] )  BL WORD ?UPPERCASE FIND ;

CR .( Interpreter )

: ?STACK      ( -- )   \ systemabhngig
     SP@ SP0 @ SWAP U< ABORT" Zu wenig Daten auf dem Stack "
     SP@ PAD        U< ABORT" Stack-berlauf" ;
DEFER STATUS
: INTERPRET   ( -- )
      BEGIN ?STACK DEFINED
       IF   EXECUTE
       ELSE NUMBER DOUBLE? NOT IF NIP THEN    \ NIP, da "little-endian"
       THEN FALSE DONE?
      UNTIL ;

CR .( Systemerweiterung, Compiler )

\ : ALLOT  ( n -- )   DP +! ;                         \ jetzt bei Eaker-Case
\ : ,      ( n -- )   HERE   ! 4 ALLOT ;              \ jetzt bei Eaker-Case
: CC,    ( cc -- )  HERE CC! 2 ALLOT ;
: C,     ( chr -- ) HERE  C! 1 ALLOT ;
: ALIGN  ( -- )
     4 HERE 3 AND - 3 AND
     BEGIN DUP 0<> WHILE BL C, 1- REPEAT DROP ; IMMEDIATE
     \ DP auf nchstgelegene Adresse mit Byteselektor = 0
     \ Zwischenstellen werden mit BL aufgefllt
\ EVEN jetzt bei TRAVERSE
DEFER ?ERROR          \ Das und (ABORT") war vorher bei ABORT"
: (ABORT")  ( fl -- ) R@ COUNT ROT ?ERROR R> COUNT + EVEN >R ;
\ : COMPILE   ( -- )    R> DUP 4+ >R  @ , ;           \ jetzt bei Eaker-Case
\ : IMMEDIATE ( -- )
\       64 ( Precedence bit ) LAST @ CSET ;           \ jetzt bei Eaker-Case
: LITERAL   ( n -- )  COMPILE (LIT) ,                          ; IMMEDIATE
: DLITERAL  ( d -- )
     SWAP [COMPILE] LITERAL [COMPILE] LITERAL                  ; IMMEDIATE
: ASCII     ( -- n )
     BL WORD  1+ C@        STATE @ IF  [COMPILE] LITERAL  THEN ; IMMEDIATE
: CONTROL   ( -- n )
     BL WORD  1+ C@ 31 AND STATE @ IF  [COMPILE] LITERAL  THEN ; IMMEDIATE
: CRASH     ( -- ) TRUE  ABORT" Vektor nicht initialisiert" ;
\ : ?MISSING ( fl -- )                                \ jetzt bei (NUMBER)
: '    ( -- cfa ) DEFINED 0= ?MISSING ;
\ ['] jetzt bei (LIT)
: [COMPILE]  ( -- )  ' , ; IMMEDIATE
: (")  ( -- ad len )   R> COUNT 2DUP + EVEN >R  ;
: (.") ( -- )          R> COUNT 2DUP + EVEN >R  TYPE ;
: ,"   ( -- )
     34 ( ASCII " ) PARSE  TUCK 'WORD PLACE  1+ ALLOT [COMPILE] ALIGN ;
: ."   ( -- )   COMPILE (.")  ," ;   IMMEDIATE
: "    ( -- )
     STATE @ IF COMPILE (") ," ELSE 34 ( ASCII " ) PARSE  THEN ; IMMEDIATE

\ CR .( Dictionary-Aufbau )

VARIABLE FENCE
: TRIM   ( fad voc-ad -- )
     #THREADS 0
     DO   2DUP @
          BEGIN   2DUP U> NOT
          WHILE  @
          REPEAT  NIP OVER ! 4+
     LOOP 2DROP ;
: (FORGET)   ( ad -- )
     DUP FENCE @ U<  ABORT" Geschtzter Dictionary-Teil"
     DUP VOC-LINK @
     BEGIN 2DUP U<
     WHILE @
     REPEAT DUP VOC-LINK ! NIP
     BEGIN DUP
     WHILE 2DUP #THREADS 4* - TRIM @
     REPEAT DROP DP ! ;
: FORGET   ( <wort> -- )
    BL WORD ?UPPERCASE DUP CURRENT @ HASH @ (FIND) 0= ?MISSING
    >LINK 4- (FORGET) ;
: FORBID ( <name> -- ad1 ad2 )        \ ad1 = lfa(name) = ad2 @
    BL WORD CAPS @
    IF DUP COUNT UPPER THEN
    CURRENT @ OVER SWAP HASH TUCK @
    (FIND) 0= ?MISSING >LINK SWAP
    BEGIN 2DUP @ = NOT
    WHILE @
    REPEAT
    2DUP
    >R @ R> ! ;
: ALLOW ( ad1 ad2 -- )                \ ad1, ad2 so, wie es von FORBID kommt
    ! ;


CR .( Systemerweiterung, Compiler )

\ DEFER ?ERROR      \ Das und (ABORT") jetzt bei EVEN
\ : (ABORT") ( fl -- ) R@ COUNT ROT ?ERROR R> COUNT + EVEN >R ;
: ABORT"   ( -- )   COMPILE (ABORT")  ," ; IMMEDIATE
: ABORT    ( -- )   TRUE ABORT" "  ;
: DEPTH    ( -- n ) SP@ SP0 @ SWAP - 4/ ;
: ?ENOUGH  ( n -- ) DEPTH 1- > ABORT" Zu wenig Daten auf dem Stack!" ;

CR .( Systemaufbau, Steuerstrukturen )

: ?CONDITION ( fl -- )    NOT ABORT" Struktur unvollstndig" ;
\ : >MARK      ( -- ad )    HERE 0 ,    ;             \ jetzt bei Eaker-Case
\ : >RESOLVE   ( ad -- )    HERE SWAP ! ;             \ jetzt bei Eaker-Case
: <MARK      ( -- ad )    HERE        ;
: <RESOLVE   ( ad -- )    ,           ;
: ?>MARK     ( -- fl ad ) TRUE >MARK  ;
: ?>RESOLVE  ( fl ad -- ) SWAP ?CONDITION >RESOLVE  ;
: ?<MARK     ( -- fl ad ) TRUE <MARK  ;
: ?<RESOLVE  ( fl ad -- ) SWAP ?CONDITION <RESOLVE  ;
: LEAVE   COMPILE (LEAVE)                              ; IMMEDIATE
: ?LEAVE  COMPILE (?LEAVE)                             ; IMMEDIATE
: BEGIN   ?<MARK  ; IMMEDIATE  : THEN ?>RESOLVE        ; IMMEDIATE
: DO      COMPILE (DO)   ?>MARK                        ; IMMEDIATE
: ?DO     COMPILE (?DO)  ?>MARK                        ; IMMEDIATE
: LOOP    COMPILE  (LOOP) 2DUP 4+ ?<RESOLVE ?>RESOLVE  ; IMMEDIATE
: +LOOP   COMPILE (+LOOP) 2DUP 4+ ?<RESOLVE ?>RESOLVE  ; IMMEDIATE
: UNTIL   COMPILE ?BRANCH    ?<RESOLVE                 ; IMMEDIATE
: AGAIN   COMPILE  BRANCH    ?<RESOLVE                 ; IMMEDIATE
: REPEAT  2SWAP [COMPILE] AGAIN   [COMPILE] THEN       ; IMMEDIATE
: IF      COMPILE  ?BRANCH  ?>MARK                     ; IMMEDIATE
: ELSE    COMPILE   BRANCH  ?>MARK  2SWAP ?>RESOLVE    ; IMMEDIATE
: WHILE   [COMPILE] IF                                 ; IMMEDIATE
\ : !CSP   ( -- ) SP@ CSP ! ;         \ !CSP CASE OF ENDOF ENDCASE
\ : CASE    CSP @ !CSP ; IMMEDIATE    \ sind jetzt bei Eaker-Case
\ : OF      COMPILE OVER COMPILE = COMPILE ?BRANCH >MARK
\           COMPILE DROP                                 ; IMMEDIATE
\ : ENDOF   COMPILE BRANCH >MARK SWAP >RESOLVE           ; IMMEDIATE
\ : ENDCASE COMPILE DROP
\           BEGIN  SP@ CSP @ <>
\           WHILE  >RESOLVE
\           REPEAT CSP !                                 ; IMMEDIATE

CR .( Systemaufbau, Definitionsworte )

: ("CREATE) ( ad b -- )
     SWAP COUNT HERE 8 + PLACE 0 , HERE 0 , HERE LAST ! HERE WARNING @
     IF   FIND
          IF   2 SPACES HERE COUNT INVERS TYPE ATTOFF
               ."  existiert bereits "
          THEN
          DROP HERE
     THEN
     CURRENT @ HASH DUP @ HERE 4- ROT ! SWAP !
     HERE DUP C@ WIDTH @ MIN DUP
     DUP >R                           \ Lnge des Namens   ; nderung 9.9.95
     HERE C! 1+ ALLOT 128 SWAP CSET
     NEGATE IF 128 HERE 1- CSET THEN
     R>  C,                           \ Extrabyte mit Lnge; nderung 9.9.95
     [COMPILE] ALIGN
     COMPILE [ [FORTH] TASSEMBLER DOCREATE , META ] ;
\ Das ursprngliche "CREATE wurde am 9.9.95  in dieses ("CREATE) umgemnzt.
\ b = 1 ist fr die englische Systemversion ( analog F83 ) gedacht. Sie er-
\ zeugt im letzten Zeichen des Namensfeldes im hchsten Bit eine 1 . b = 0
\ erzeugt dort keine 1 und ist fr die deutsche Systemversion gedacht, die
\ auch Umlaute in den Wortnamen zulsst.
: "CREATE-ENG 1 ("CREATE) ;
: "CREATE-GER 0 ("CREATE) ;
DEFER "CREATE
: CREATE  ( <wort> -- ) [COMPILE] ALIGN BL WORD ?UPPERCASE "CREATE ;
\ : !CSP  ( -- ) SP@ CSP ! ;   \ Jetzt bei WHILE
: ?CSP    ( -- ) SP@ CSP @ <> ABORT" Stack nicht ausgeglichen" ;
: HIDE    ( -- ) LAST @ DUP N>LINK @ SWAP CURRENT @ HASH ! ;
: REVEAL  ( -- ) LAST @ DUP N>LINK   SWAP CURRENT @ HASH ! ;
\ : (;USES) ( -- ) R> @ LAST @ NAME> ! ;        \ Bisherige Version - 12.9.95
: (;USES) ( -- ) R> @ LAST @ DUP C@ 31 AND + 2 + EVEN ! ;
\ Diese neue Version vom 12.9.95 ntzt fr den Sprung  von nfa zu cfa  die im
\ ersten Byte des Namensfeldes  gespeicherte Stringlnge.  Die zustzlich  in
\ die Definition von (;USES)  eingebauten Worte sind genau die Worte,  die in
\ NAME>-GER  ( siehe TCORE.FTH )  vorkommen.  Diese Umgestaltung  kann meiner
\ Meinung nach  nirgendwo schaden.  Es kommt ja nur auf die Funktion an.  Und
\ die bleibt dieselbe.  Das neue (;USES) kann nun aber auch bei Namen verwen-
\ det werden, die Zeichen mit ASCII-Wert ber 127 ( z.B. Umlaute ) enthalten.
VOCABULARY ASSEMBLER
: ;USES   ( -- ) ?CSP COMPILE (;USES) [COMPILE] [ REVEAL ; IMMEDIATE
\ : (;CODE) ( -- ) R> LAST @ NAME> ! ;          \ Bisherige Version - 12.9.95
: (;CODE) ( -- ) R> LAST @ DUP C@ 31 AND + 2 + EVEN ! ;
\ Fr diese neue Version vom 12.9.95 gilt dasselbe wie das, was bei (;USES)
\ gesagt wurde.
: ;CODE   ( -- )
     ?CSP COMPILE (;CODE) [COMPILE] [ CONTEXT @ AVOC ! ASSEMBLER ; IMMEDIATE
\ Achtung: Der Assembler-Code nach (;CODE) muss mit END-CODE
\ abgeschlossen werden, damit wieder von ASSEMBLER auf das
\ ursprngliche Vokabular zurckgeschaltet wird.
HEX
[ASSEMBLER] DODOESP DODOES DODOESP D2* D2* WPTR D+ !-T [FROM]
: DOES>   ( -- )
     COMPILE (;CODE)
     40 C,                            \ Zum Wortausgleich
     21 C,                            \ DODOESP high ( noch von oben auf Stack )
     LITERAL [ 0 ] 0F AND 70 OR C,    \ DODOESP low LDL
     0F6 C, ; IMMEDIATE               \ GCALL
: [ ( -- ) STATE OFF ; IMMEDIATE
: ] ( -- ) STATE ON
     BEGIN ?STACK DEFINED DUP
       IF 0> IF EXECUTE ELSE , THEN
       ELSE DROP NUMBER DOUBLE?
         IF [COMPILE] DLITERAL
         ELSE NIP [COMPILE] LITERAL
         THEN
       THEN TRUE DONE?
     UNTIL ;
: : ( -- ) !CSP CURRENT @ CONTEXT ! CREATE HIDE ] ;USES NEST ,
: ; ( -- ) ?CSP COMPILE UNNEST REVEAL [COMPILE] [ ; IMMEDIATE
: RECURSIVE ( -- )  REVEAL   ; IMMEDIATE
: CONSTANT ( n -- ) CREATE   , ;USES DOCONSTANT ,
: VARIABLE ( -- )   CREATE 0 , ;USES DOCREATE ,
: STRING ( n -- <namevar$> beim Compilieren )
     CREATE DUP C, 0 C, DP +! HERE EVEN DP ! ;USES DOSTRING ,
: $! ( str strvar -- ) DROP 1- DUP 1- C@ ROT MIN SWAP PLACE ;
: DEFER ( -- ) CREATE ['] CRASH , ;USES DODEFER ,
: VOCABULARY  ( -- )
     CREATE  #THREADS 0  DO 0 , LOOP
     HERE VOC-LINK @ , VOC-LINK ! DOES> <VOCABULARY> CONTEXT ! ;
: DEFINITIONS ( -- ) CONTEXT @ CURRENT ! ;
: 2CONSTANT ( d -- ) CREATE     , , ;USES DO2CONSTANT ,
: 2VARIABLE ( -- )   CREATE 0 0 , , ;USES DO2CREATE ,
: CODE ( -- ) CREATE  HIDE  HERE DUP 4- !  CONTEXT @ AVOC !  ASSEMBLER  ;

ASSEMBLER DEFINITIONS
: END-CODE  [COMPILE] ALIGN  AVOC @ CONTEXT !  REVEAL ;

\ Und jetzt noch die Systemvariablen:
\ Die folgenden Systemkonstanten werden jetzt in das Vokabular ASSEMBLER des
\ gerade im Aufbau befindlichen Systems  metacompiliert.  Bei nachtrglicher
\ nderung reicht es,  sie  an der Stelle ihrer Erstdefinition  im SERVER zu
\ ndern. Bei nachtrglicher nderung beachte man, dass Sprnge mit CJ, d.h.
\ Sprnge,  die nicht  ber Strukturelemente  ( IF, ELSE, THEN, WHILE usw. )
\ gebildet werden, in der anzusetzenden Lnge gegebenenfalls von der Zahlen-
\ lnge der Konstanten  ( 8 = ohne Prfix,  12 = mit Prfix usw. ) abhngen.
\ Verwendungsbeispiel fr die Konstante SP ( es werden im Sinne von SWAP die
\ oberen beiden Stackelemente vertauscht ):
\ SP LDL 0 LDNL  SP LDL 1 LDNL  SP LDL 0 STNL  SP LDL 1 STNL

: IP      [ [ASSEMBLER] IP     [FROM] ] LITERAL ; \ Instruction-Pointer
: W       [ [ASSEMBLER] W      [FROM] ] LITERAL ; \ W-Register
: RP      [ [ASSEMBLER] RP     [FROM] ] LITERAL ; \ Returnstack-Pointer
: SP      [ [ASSEMBLER] SP     [FROM] ] LITERAL ; \ Datenstack-Pointer
: AREG    [ [ASSEMBLER] AREG   [FROM] ] LITERAL ; \ Pseudoregister zur Zwischen-
                                                  \ ablage ( von Areg )
: BREG    [ [ASSEMBLER] BREG   [FROM] ] LITERAL ; \ Pseudoregister zur Zwischen-
                                                  \ ablage ( von Breg )
: CREG    [ [ASSEMBLER] CREG   [FROM] ] LITERAL ; \ Pseudoregister zur Zwischen-
                                                  \ ablage ( von Creg )
: DREG    [ [ASSEMBLER] DREG   [FROM] ] LITERAL ; \ Pseudoreg. fr Extrazwecke
: EREG    [ [ASSEMBLER] EREG   [FROM] ] LITERAL ; \ Pseudoreg. fr Extrazwecke
: FREG    [ [ASSEMBLER] FREG   [FROM] ] LITERAL ; \ Pseudoreg. fr Extrazwecke
: GREG    [ [ASSEMBLER] GREG   [FROM] ] LITERAL ; \ Pseudoreg. fr Extrazwecke
: HREG    [ [ASSEMBLER] HREG   [FROM] ] LITERAL ; \ Pseudoreg. fr Extrazwecke
: BPUSHP  [ [ASSEMBLER] BPUSHP [FROM] ] LITERAL ; \ bewahrt Adresse BPUSH auf
: CPUSHP  [ [ASSEMBLER] CPUSHP [FROM] ] LITERAL ; \ bewahrt Adresse CPUSH auf
: NEXTP   [ [ASSEMBLER] NEXTP  [FROM] ] LITERAL ; \ Label-Adresse von >NEXT
: COLDP   [ [ASSEMBLER] COLDP  [FROM] ] LITERAL ; \ Adresse des Einsprung-
                                                  \ punktes zu Coldstart
: WARMP   [ [ASSEMBLER] WARMP  [FROM] ] LITERAL ; \ Adresse des Einsprung-
                                                  \ punktes zu Warmstart
: DODOESP [ [ASSEMBLER] DODOESP [FROM] ] LITERAL ; \ Adresse des Einsprung-
                                                   \ punktes zu DODOES
: 'QUIT   [ [ASSEMBLER] 'QUIT  [FROM] ] LITERAL ; \ cfa von QUIT
: 'BOOT   [ [ASSEMBLER] 'BOOT  [FROM] ] LITERAL ; \ cfa von BOOT
: NESTP   [ [ASSEMBLER] NESTP  [FROM] ] LITERAL ; \ Label-Adresse von NEST
: WPTR    [ [ASSEMBLER] WPTR   [FROM] ] LITERAL ; \ Wert des Workspace-Pointers
                                                  \ nach dem Meta-Compilieren

FORTH DEFINITIONS  META IN-META
VARIABLE #USER
VOCABULARY USER  USER DEFINITIONS
: ALLOT ( n -- ) #USER +! ;
' CREATE  ( hinterlsst die Adresse fr  ,  in CREATE )
: CREATE ( -- ) [ , ] #USER @ , ;USES DOUSER-VARIABLE ,
: VARIABLE ( -- ) CREATE  4 ALLOT ;
: DEFER ( -- ) VARIABLE ;USES DOUSER-DEFER  ,

\ Achtung: Ab hier keine definierenden Worte mehr in TKERNEL definieren.
\ Andernfalls wrde der Meta-Compiler, der ja lediglich das Vokabular
\ TARGET hat, Worte aus USER verwenden. Konkret: Keine Doppelpunktworte
\ mehr verwenden, die CREATE ALLOT VARIABLE oder DEFER enthalten. Inter-
\ pretative Verwendung bleibt erlaubt.

FORTH DEFINITIONS  META IN-META
: >IS ( cfa -- data-ad )
      DUP @
      DUP [  [ASSEMBLER] DOUSER-VARIABLE META ] LITERAL = SWAP
      DUP [  [ASSEMBLER] DOUSER-DEFER    META ] LITERAL = SWAP
      DROP   OR IF >BODY @ UP @ + ELSE >BODY THEN ;
: (IS) ( cfa -- )  R@ @  >IS !   R> 4+ >R ;
: IS   ( cfa -- )  STATE @ IF COMPILE (IS) ELSE ' >IS ! THEN ; IMMEDIATE

CR .( Initialisierung auf oberer Ebene )

: RUN  ( -- )
     STATE @
     IF   ] STATE @ NOT  IF INTERPRET THEN
     ELSE INTERPRET
     THEN ;
VARIABLE SYS-ID
: .OK  ( -- )
     BOLD ." OK " ATTOFF ." im Transputer-FORTH-" SYS-ID C@ ?DUP 0<>
       IF ." Subsystem " . ELSE ." System" THEN
       ." . Zum Host mit BYE [RET] oder [ESC]." ;
: QUIT ( -- )
     ?SCREEN@-OFF                     \ Zeichen-Einsammeln ausschalten.
     TIB0 @ 'TIB ! [COMPILE] [        \ Ursprnglich SP0 @ statt TIB0 @  !!!
     BEGIN RP0 @ RP! STATUS QUERY RUN
       STATE @ NOT
       IF CR .OK THEN
     AGAIN ;
DEFER BOOT
: WARM ( -- ) TRUE ABORT" Soeben wurde Warmstart gegeben" ;
FORCED
: COLD ( -- ) BOOT QUIT ;
UNFORCED
HEX
: SET-DMA ( ad -- ) 1A BDOS DROP ;    \ setzen  der DOS-Disk-Transfer-Address
CODE DMA ( ad -- ad )                 \ 128 Byte von Host-DMA nach Adresse ad
      MINT   82 LDC  OUTBYTE          \ Transfer-Code
      SP LDL  0 LDNL                  \ TAdresse ad
      MINT   10 ADC                   \ Eingabekanal
             80 LDC  IN               \ 128 Byte einholen
      NEXT END-CODE
: PATHWAY ( <path\filename[.ext]> -- ad-ascii0 )
      BL WORD DSEGMENT FLIP HERE-HOST OR OUTWDBUF OUT$ 0 H$B! HERE-HOST 1+ ;
      \ PATHWAY  hat in etwa  dieselbe Aufgabe wie
      \ FILENAME, gibt aber keine .FTH-Kennung vor
: DRV ( -- drv) 0E INBYTE ; \ Laufwerk erfragen

\ MKDIR RMDIR CHDIR DEL jetzt in TCORE.FTH


DECIMAL
CR .( Dateiname erfassen und ASCII0-String erzeugen )

 4 STRING EXT$      \ normalerweise: ext = " .FTH" | " .COM"
64 STRING COMMAND$  \ bergibt Befehlsstring in (WHERE) und PASS
: FILENAME ( <path\filename[.ext]> -- ad-ascii0 )
      BL WORD COUNT ASCII . SCAN NIP 0= \ Suche nach Datei-Erweiterung
      IF EXT$ HERE COUNT + SWAP DUP >R MOVE R> HERE +! THEN
      HERE DSEGMENT FLIP HERE-HOST OR OUTWDBUF OUT$ 0 H$B! HERE-HOST 1+ ;
: CLOSE  ( -- )  \ Schliet die laufende Datei
      HANDLE @ ?DUP IF (CLOSE) THEN EOF? OFF ;
: ALLCLOSE  ( -- )  \ Schliet alle noch offenen Dateien
      FILES 0  DO 29 I + C@ 255 <>  IF I 5 + (CLOSE) THEN  LOOP  EOF? OFF ;
: PATHNAME! ( ad len -- )  \ Schreibt PATHNAME in Puffer
      PATHNAME DUP C/PATH BLANK SWAP CMOVE ;
: MKFILE ( <datei[.ext]> att -- hndl )  \ Datei der Lnge 0 einrichten
      ?OPEN FILENAME SWAP (CREATE) 0<> IF ?DOS-ERR THEN
      HANDLE @ >R HANDLE ! HERE COUNT PATHNAME! LINE# OFF
      HANDLE @ R> HANDLE ! ;
: OPEN  ( <datei[.ext]> -- hndl )     \ ffnet eine Datei zum Lesen
      ?OPEN FILENAME 0 (OPEN) 0<> IF ?DOS-ERR THEN
      HANDLE @ >R HANDLE ! HERE COUNT PATHNAME! 0 LINE# CC!
      HANDLE @ R> HANDLE ! ;
: GET ( -- c )  \ Zeichen aus der laufenden Datei lesen
     HANDLE @ 0=
     IF (KEY)
     ELSE DSEGMENT PAD-HOST 1 HANDLE @ (GET) 0<>
       IF EOF 13
       ELSE 1 =
         IF   DSEGMENT FLIP PAD-HOST OR OUTWDBUF PAD IN$ PAD C@
         ELSE EOF 13
         THEN
       THEN
     THEN ;
: .LINE CR BUFFER COUNT -TRAILING TYPE ;
: GETLINE ( -- )  \ Zeile mit oder ohne Echo aus dem Puffer lesen
     PAD-HOST HANDLE @ (GETLINE) EOF? ! LINE# 1+!
     DSEGMENT FLIP PAD-HOST OR OUTWDBUF BUFFER IN$
     ECHO @ IF .LINE THEN ;
: (SOURCE) ( -- ad len )
     HANDLE @ IF BUFFER COUNT ELSE TIB #TIB @ THEN ;
DEFER WHERE
: (?ERROR) ( ad len fl -- )
      IF   PRINTING OFF SPACE BOLD TYPE ATTOFF SPACE SP0 @ SP!
           HANDLE @  IF WHERE HANDLE OFF THEN
           ALLCLOSE  QUIT
      ELSE 2DROP
      THEN ;
VARIABLE IN-LINE  \ Zeilennummer  fr den eventuellen Gebrauch aufbewahren
VARIABLE IN-CHAR  \ Spaltennummer fr den eventuellen Gebrauch aufbewahren
: (WHERE)
     CR ." in "
     PATHNAME C/PATH -TRAILING  2DUP COMMAND$ $!  TYPE SPACE
     BASE @ DECIMAL  ." in Zeile "
     LINE#  DUP CC@ IN-LINE ! CC@ . .LINE  BASE !
     CR >IN @  DUP IN-CHAR !  SPACES INVERS 94 EMIT ATTOFF CR ;
: INCLUDE ( <datei> -- )
     EXT$ PAD PLACE " .FTH" EXT$ $!   \ Extension .FTH als Vorgabe
     OPEN                             \ Datei ffnen
     PAD COUNT EXT$ $!                \ Wieder ursprngliche Vorgabe
     HANDLE @ >R >IN @ >R             \ Bisherige Dateikennung aufbewahren
     HANDLE !                         \ Auf gerade geffnete Datei schalten
     BEGIN GETLINE >IN OFF            \ Eine Zeile einlesen
          RUN EOF? @                  \ Bis zum EOF interpretieren
     UNTIL CLOSE                      \ Gerade bearbeitete Datei schlieen
     R> >IN ! R> HANDLE ! ; IMMEDIATE \ Zugang zur bisherigen Datei
                                      \ wiederherstellen

\ : REN ( <filename1 filename2> -- ) liegt jetzt in TCORE.FTH


CR .( Reentrante String-Mehrfachinterpretation )

VARIABLE (STR$) 0 ,-T         \ Das 0 ,-T macht aus (STR$) eine 2VARIABLE
: STR$ ( -- ad len ) (STR$) 2@ ;
     \ Ursprnglich stand hier 0 0 2CONSTANT STR$ . Ich habe aber fr die
     \ Metacompilation keine  im Sinne des TSystems doppeltgenauen Zahlen
     \ zugelassen,  da diese  ja dann  im Host-System vierfach genau sein
     \ mssten.
VARIABLE #STRINGS  \ Zahl der ineinandergeschachtelten Strings
: SOURCE$  ( -- ad len )
     HANDLE @ 0< IF STR$ ELSE (SOURCE) THEN ;
: ?ERROR$  ( ad len fl -- )
     DUP
     IF ['] (SOURCE) IS SOURCE   ['] (?ERROR) IS ?ERROR
          HANDLE @ 0<
          IF HANDLE OFF CR
          ." String '"
          STR$ TYPE ." ' :"
          THEN #STRINGS OFF
     THEN (?ERROR)  ;
: $EXECUTE  ( ad len -- )
     #STRINGS 1+!  ['] SOURCE$ IS SOURCE  ['] ?ERROR$ IS ?ERROR
     STR$ >R >R   (STR$) 2!  >IN @ >R  >IN OFF
     HANDLE @ >R  #STRINGS @ NEGATE HANDLE !  RUN
     #STRINGS 1-!
     #STRINGS @ 0=
     IF ['] (?ERROR) IS ?ERROR ['] (SOURCE) IS SOURCE THEN
     R> HANDLE ! R> >IN !  R> R> (STR$) 2! ;
     \ $EXECUTE fhrt einen explizit angegebenen (Befehls-)String aus.
     \ Dieses Wort  ist ein mchtiges Hilfsmittel  zur Ausnutzung  der
     \ Fhigkeit von FORTH, gleichzeitig interpretierend wie auch com-
     \ pilierend zu wirken.  Die Reentranz der Interpretation  ist in-
     \ nerhalb der Grenzen  der Kapazitt des Returnstacks  gewhrlei-
     \ stet.  Genau so,  wie man die Ausfhrung von Dateien schachteln
     \ kann,  kann  auch  die Interpretation von Strings  geschachtelt
     \ werden.  Der grundlegende Zeiger  bleibt  nach wie vor  HANDLE,
     \ dessen Wertebereich  jetzt jedoch  auf negative Werte erweitert
     \ wird.
     \ Siehe auch  $EXECUTE-HOST  in TCORE.FTH , mit welchem Wort fast
     \ jeder Zugriff  auf das Host-FORTH-System  erledigt werden kann.


CR .( Inhalt einer Diskette anzeigen, Directory )

\ VARIABLE ATTDIR, .NAME0, .NAME1, .NAME2, (DIR) und DIR liegen jetzt
\ in TCORE.FTH. Der Server mit Cross-Assembler und Metacompiler waren
\ zu gro geworden.

DECIMAL
: FREE  ( -- len len' )     \ len' = noch freier, len = berhaupt vorhandener
     0 (FREE) TUCK * >R *  \ Platz auf dem eingeschalteten Laufwerk
     OVER * SWAP R> * ;
: STOP? ( -- fl )          \ fl = TRUE, wenn CR gedrckt
     FALSE KEY? IF DROP KEY DROP KEY 13 = THEN ;


CR .( RAM-Bereich auf Diskette speichern )
HEX

: SAVE  ( <filename[.EXT]> ad1 ad2 -- )
     2DUP >= ABORT" Dateilnge <= 0"
     ?OPEN DRV >R                     \ S: ad1 ad2      R: #drv
     EXT$ PAD PLACE " .COM" EXT$ $!   \ EXT = .COM als Vorgabe
     FILENAME >R                      \ S: ad1 ad2      R: #drv host-ad-ascii0
     PAD COUNT EXT$ $!                \ Wieder ursprngliche Vorgabe
     HERE 2+ C@ ASCII : =             \ Fngt Filename mit x: an ?
     IF   HERE 1+ C@ UPC
          ASCII A - SELECT            \ Angewhltes Laufwerk einschalten
     THEN
     2DUP SWAP -                      \ S: ad1 ad2 ad2-ad1
     FREE NIP >R R@ >                 \ R: #drv host-ad-ascii0 free-bytes
     IF   CR ." Nur noch "            \ Wenn kein Platz, dann Fehlermeldung
          BASE @ DECIMAL R> .         \ S: ad1 ad2 base   R: #drv host-ad-ascii0
          ." Bytes auf "
          DRV ASCII A + EMIT
          ASCII : EMIT
          ." . Bentigt werden "
          -ROT 2DUP SWAP - . ROT
          ." !" BASE ! R> DROP        \ S: ad1 ad2        R: #drv
          R> SELECT ABORT
     ELSE R> DROP                     \ S: ad1 ad2        R: #drv host-ad-ascii0
     THEN
     R> 0 (CREATE) ?DOS-ERR >R        \ S: ad1 ad2        R: #drv hndl
     BEGIN
       2DUP >
       ABORT" Eingabefehler !"        \ S: ad1 ad2
       2DUP SWAP - 0F000 - 0>=        \ S: ad1 ad2
       IF   SWAP DUP DUP 0F000 +      \ S: ad2 ad1 ad1 ad1+f000
            (PUT) 0F000               \ S: ad2 ad1 f000
            DSEGMENT 1000 + 0 0F000   \ S: ad2 ad1 f000 seg+1000 0 f000
            R@ PUT-HOST ?DOS-ERR <>   \ S: ad2 ad1 f000 len'  R: #drv hndl
            ABORT" Schreibfehler !"   \ S: ad2 ad1
            0F000 + SWAP 0            \ S: ad1+f000 ad2 0
       ELSE 2DUP SWAP - -ROT          \ S: ad2-ad1 ad1 ad2
            TRUE -ROT                 \ S: ad2-ad1 -1 ad1 ad2
            (PUT) SWAP DUP            \ S: -1 ad2-ad1 ad2-ad1
            DSEGMENT 1000 + 0 ROT
            R@ PUT-HOST ?DOS-ERR <>   \ S: -1 ad2-ad1 len'    R: #drv hndl
            ABORT" Schreibfehler !"   \ S: -1
       THEN
     UNTIL
     R> (CLOSE)                       \ Eben-beschriebene Datei schlieen
     R> SELECT ;                      \ Wieder ursprngliches Laufwerk

: SAVE-SYSTEM ( <filename[.COM]> )  WPTR HERE SAVE ;
     \ Vorsicht: WPTR entspricht dem spteren WPTR @ . Aus dem fertigen
     \ System heraus msste also  WPTR @ HERE SAVE  zur Nachbildung von
     \ SAVE-SYSTEM verwendet werden.

HEX
CR .( Transputer-FORTH verlassen )

FORCED
VARIABLE PARAM-BYE   \ Zur bergabe von Errorlevel-Codes bei BYE-FOR-DOS usw.
CODE (BYE)        ( -- ) \ Zurck zum Host-Turbo-FORTH-System
     MINT        2B LDC   OUTBYTE     \ Transfer-Funktion
     MINT         4 LDC   OUTBYTE     \ Message-Lnge
     PARAM-BYE LDC
     MINT         4 LDC   OUT         \ 32-Bit-bergabe fr PARAM-BYE im Host
     START                            \ Transputer in Reset
     NEXT END-CODE

CODE BYE-FOR-DOS  ( -- ) \ Zurck zu DOS. Errorlevel wird von PARAM-BYE geholt.
     MINT         8 LDC   OUTBYTE     \ Transfer-Funktion
     MINT         1 LDC   OUTBYTE     \ Message-Lnge
     MINT PARAM-BYE LDC
                     LB   OUTBYTE     \ Errorlevel-Code
     START                            \ Transputer in Reset versetzen
     NEXT END-CODE


HEX
CR .( Initialisierung auf unterer Ebene )

ALIGN-T
HERE-T [ASSEMBLER] WPTR WARMP D2* D2* D+ ( warm entry ) [FROM] !-T
' WARM >BODY [ASSEMBLER] LDC  IP STL  NEXT  [FROM]
ALIGN-T
HERE-T [ASSEMBLER] WPTR COLDP D2* D2* D+ ( cold entry ) [FROM] !-T
TIB0 @-T [ASSEMBLER] LDC [FROM] 'TIB [ASSEMBLER] LDC 0 STNL [FROM]
UP @-T 10 D+ ( RP0 ) @-T [ASSEMBLER] LDC  RP STL [FROM]
UP @-T 0C D+ ( SP0 ) @-T [ASSEMBLER] LDC  SP STL [FROM]
' COLD >BODY         [ASSEMBLER] LDC  IP STL  NEXT   [FROM]

CR .( USER-Variablen einrichten und initialisieren )  \ jetzt weiter vorn

DECIMAL
CR .( Hilfsprogramme )

UNFORCED
: .S ( -- )
      DEPTH ?DUP
      IF 0 DO DEPTH I - 1- PICK 7 U.R SPACE KEY? ?LEAVE LOOP
      ELSE BOLD ." Stack leer " ATTOFF THEN ;
VARIABLE <IP  \ Wird von TRACE beim schrittweisen Interpretieren verwendet

: .ID-ENG ( nfa -- )
     DUP <IP @ 4+ >NAME = IF BOLD THEN \ hervorgehoben, wenn Wort im TRACE-Mode
     DUP 1+ DUP C@ ROT C@ 31 AND 0
     ?DO DUP 127 AND EMIT 128 AND
     IF ASCII _ 128 OR
     ELSE  1+ DUP C@
     THEN
     LOOP ATTOFF 2DROP SPACE ;
\ Das war das ursprngliche .ID .  Jetzt ( 9.9.95 ) wird .ID per GERMAN oder
\ ENGLISH nach .ID-GER oder .ID-ENG geschaltet. .ID-ENG ist fr Systeme, die
\ ( analog F83 ) im Namensfeld  auf eine 1  im hchsten Bit des letzten Zei-
\ chens testen.

DEFER .ID

CR .( STATUS des Systems anzeigen )

VARIABLE STATUS?  \ berwachungsregister von (STATUS)
: (STATUS) ( -- )
     CR STATUS? @
     IF BASE @ DECIMAL  DEPTH 1- . DUP 8 =
       IF ."  (oct) "
       ELSE DUP 10 =
         IF   ."  (dec) "
         ELSE DUP 16 =
           IF   ."  (hex) "
           ELSE DUP DECIMAL 0
                <#  BL HOLD ASCII ) HOLD  # #  ASCII # HOLD
                ASCII ( HOLD  BL HOLD #> TYPE
           THEN
         THEN
       THEN BASE !
     THEN ;
\ Vektorisiert durch  ' (STATUS) IS STATUS

CR .( Vokabularinhalt anzeigen )

VARIABLE LMARGIN
VARIABLE RMARGIN
: ?LINE  ( n -- )
     #OUT @ + RMARGIN @ > IF CR  LMARGIN @ SPACES THEN ;
: ?CR ( -- )
     0 ?LINE ;
: LARGEST  ( adr n -- adr' val)
     OVER 0 SWAP ROT 0
     DO 2DUP @ U<
          IF -ROT 2DROP DUP @ OVER
          THEN
      4+ LOOP DROP ;
: ?TAB ( n -- )  \ Sprung auf n Spalten weiter
     LMARGIN @ #OUT @ - SWAP MOD SPACES ;
: WORDS ( -- )
     CR LMARGIN @ SPACES
     CONTEXT @
     HERE #THREADS 4* CMOVE
     BEGIN
       HERE #THREADS LARGEST
       DUP STOP? NOT AND WHILE
       DUP L>NAME
           12 ?TAB
           DUP C@ 31 AND ?LINE
           .ID
       @ SWAP !
     REPEAT
     2DROP ;
\ Da die Handhabung eines Editors recht umstndlich ist, wurde das Wort LIST
\ hinzugefgt. Damit kann man sich eine ASCII-Datei schnell ansehen.
\ Alte Version 20.9.95
\ : LIST ( <filename> -- )            \ Textdatei ansehen
\   ECHO @ HANDLE @ ECHO ON
\   OPEN HANDLE !
\   BEGIN GETLINE STOP? EOF? @ OR UNTIL CLOSE
\   HANDLE ! ECHO ! ;

\ Die neue Version habe ich nach TCORE.FTH verbannt, da TKERNEL.FTH fr den
\ Metacompiler zu lang geworden war. - 20.9.95

CR .( Weiteres )

\ : RECURSE ( -- ) LAST @ NAME> , ; IMMEDIATE   \ Bisherige Version - 12.9.95
: RECURSE ( -- ) LAST @ DUP C@ 31 AND + 2 + EVEN , ; IMMEDIATE
\ Fr diese neue Version vom 12.9.95 gilt dasselbe wie das, was bei (;USES)
\ gesagt wurde.

VARIABLE FUDGE
: MS      ( n -- ) 0 ?DO FUDGE @ 0  ?DO LOOP  LOOP  ;
VARIABLE #TIMES  ( wie oft schon ausgefhrt ? )
: TIMES   ( n -- )
     #TIMES 1+!  #TIMES @  < IF  1 #TIMES !  ELSE  >IN OFF  THEN ;
: MANY    ( -- ) KEY? NOT IF >IN OFF THEN ;


CR .( Verwaltung der Host-Bildschirm-Attribute )
DECIMAL

VARIABLE GRMODE  \ Graphik-Modus:
                 \ 0 = 40 x 25 schwarz/wei
                 \ 1 = 40 x 25 farbig
                 \ 2 = 80 x 25 schwarz/wei
                 \ 3 = 80 x 25 farbig
CODE ((MODE)) ( n -- )                \ Bildschirmmodus auf GRMODE setzen
      MINT          6 LDC   OUTBYTE   \ Transfer-Funktion
      MINT          1 LDC   OUTBYTE   \ Message-Lnge
      MINT  SP LDL  0 LDNL  OUTBYTE   \ Inhalt von GRMODE
      SP LDL  4 ADC  SP STL  NEXT END-CODE
: (MODE) GRMODE @ ((MODE)) ;
\ : DARK  ( -- )
\       NOOP  #LINE OFF  #OUT OFF ;
\ Wird initialisiert durch  ' (MODE) IS DARK
\ Dark jetzt weiter vorn bei BYE
: MODE ( n -- )
      GRMODE !  DARK ;


CR .( Speicherbereich DUMPen )
HEX

VARIABLE ASCFILT                      \ Bei DUMP nur ASCII-Zeichen ausgeben ?
: ?ASCII ( n1 -- n2 )                 \ Nicht-ASCII-Zeichen --> Punkt ?
     ASCFILT @                        \ TRUE = ja
     IF
       DUP 20 7E BETWEEN NOT          \ nicht ASCII ?
       IF  DROP 2E  THEN              \ dann Punkt
     ELSE
       DUP    7  =                    \ Bell
       OVER   8  =  OR                \ Del
       OVER   A  =  OR                \ Linefeed
       OVER   D  =  OR                \ CR
       OVER  1B  =  OR                \ ESC
       OVER 0FF  =  OR                \ Bell usw. ?
       IF  DROP BL  THEN              \ dann Blank
     THEN ;
: DUMP^ ." 0  1  2  3  4  5  6  7   8  9  A  B  C  D  E  F  0123456789ABCDEF" ;
: DUMP ( ad len -- )                  \ Stop: SPACE. Weiter: SPACE. Exit: CR CR
     CR BASE @ HEX -ROT OVER 0 SWAP   \ Mehr: + . Nochmal zurck: -
     10 UM/MOD DROP >R SWAP R@ - R>
     DUP 3 * DUP 17 > IF 1+ THEN 0A + (CURSOR) NIP 0B SWAP AT DUMP^
     (CURSOR) NIP AT BOLD ." \/" 3C + (CURSOR) NIP AT ." V" ATTOFF CR
     BEGIN
       BEGIN
         2DUP <# # # # # # # # # #> TYPE SPACE SPACE     \ Adresse anzeigen
          8 0 DO DUP C@ DUP <# # # #> TYPE SPACE 1+ LOOP SPACE
          8 0 DO DUP C@ DUP <# # # #> TYPE SPACE 1+ LOOP SPACE  10 -
         10 0 DO DUP C@             ?ASCII  EMIT 1+ LOOP CR
         SWAP 10 - TUCK
         0<= STOP? OR                 \ Ende oder Abbruch ?
       UNTIL
       (CURSOR) DUP 18 = IF 0 0 AT 0B SPACES DUMP^ THEN AT
       BOLD (CURSOR) -1 0 (FRAME) ." Weiter: +   Zurck: -   Exit: RET"
       ATTOFF AT
       KEY
       DUP ASCII + = IF  ROT DROP 100 -ROT DROP
                    FALSE ELSE
           ASCII - = IF SWAP DROP 100 SWAP 200 - DARK 0B 0 AT DUMP^ CR
                    FALSE ELSE
       2DROP BASE ! TRUE  THEN  THEN
     UNTIL 0C 0D (FRAME) CR ;

: SET-EOS ( ad-- )                    \ Nachtrgliches Versetzen des
     -4 AND                           \ auf Wortgrenze abgerundeten
     DUP HERE 1000 + <=               \ Endes des T-Forth-Systems.
     IF ABORT" Endadresse zu niedrig! Kein Platz fr System." THEN
      55 OVER C! DUP C@  55 <> SWAP
     0AA OVER C! DUP C@ 0AA <> ROT OR
     IF ABORT" Zu wenig Transputer-RAM ?" THEN
     EOS !
     EOS @                            \ Jetzt unter Beachtung des
     1 0FF + 2 + 40 + 8 * -           \ fr 8 mal LBUF bentigten
     UP @ 0C + !                      \ Platzes SP0 neu eintragen
     SP0 @ SP! ;                      \ und Stack anpassen.

DECIMAL

130 STRING BOOT$                      \ Fr DOS-Kommandozeilenstring

: START  ( -- ) \ Befehlsstring ausfhren, der beim Booten bergeben wurde
     BOOT$ DROP 1- DMA COUNT          \ ad len
     DUP 1 >                          \ Wenn kein String hinter ^,
     IF                               \ dann keiner zu bernehmen.
       TUCK 0 TUCK                    \ len ad 0 len 0
       ?DO
         DROP
         DUP I + C@ ASCII ^ =         \ Auf Begrenzer 5Eh prfen
         IF I LEAVE THEN I            \ ^ an letzter Stelle dasselbe wie kein ^
       LOOP                           \ len ad I (I = Offset Begrenzerposition)
       TUCK                           \ len I ad I
       + 1+                           \ len I ad+I+1
       -ROT - 1-                      \ ad+I+1 len-I-1 ( Reststring )
       $EXECUTE                       \ Kommando hinter ^ ausfhren
     ELSE 2DROP                       \ ad,len beseitigen, wenn kein Reststring
     THEN ;


CR .( Allerletztes Wort in TKERNEL.FTH )

: KERNEL ( -- )
     FORTH DEFINITIONS                \ Alle Bezge auf Dinge  in TCORE.FTH
     ['] NOOP IS UPDATE-FORTHKEY      \ wieder wegnehmen,  da diese ja nach
     ['] NOOP IS ?SCREEN@-OFF         \ Bettigung  von  KERNEL  nicht mehr
     ['] NOOP IS HOTKEYS              \ gelten  -  jedenfalls hchstens so-
       7 FENCE !                      \ lange, bis der Platz, den TCORE.FTH
       7 (FORGET) ;                   \ eingenommen hat, berschrieben wird.
                                      \ 7 = Platzhalter ( siehe unten )
                                      \ 7 = Platzhalter ( siehe unten )
                                      \ Aufruf von KERNEL reduziert
                                      \ das System auf den KERNEL.
                                      \ Das Wort KERNEL bleibt.

HERE-T HERE-T 12 D- !-T               \ Diese Adresse, das ist die erste
HERE-T HERE-T 28 D- !-T               \ Adresse  nach  dem Wort  KERNEL,
                                      \ wird jetzt in das Wort KERNEL so
                                      \ eingebracht, dass bei Aufruf von
                                      \ KERNEL  die Variable  FENCE  auf
                                      \ diese Adresse  gesetzt  und  an-
                                      \ schlieend alles, was auf KERNEL
                                      \ folgt, (FORGET)et wird.
ALIGN-T

CR .( DEFERierte Worte initialisieren )

' (KEY?)      IS KEY?
' (KEY)       IS KEY
' CRLF        IS CR
' (STATUS)    IS STATUS
' (CHAR1)     IS CHAR1
' (BYE)       IS BYE
' (SOURCE)    IS SOURCE
' START       IS BOOT   \ Wird unmittelbar nach dem Laden von FORTH ausgefhrt
' (NUMBER)    IS NUMBER
' (?ERROR)    IS ?ERROR
' (WHERE)     IS WHERE
' (AT)        IS AT
' (MODE)      IS DARK
' (FIND)-ENG  IS (FIND) \ Zunchst Versionen,  die keine Zeichen  mit ASCII-
' NAME>-ENG   IS NAME>  \ Werten ber 127 ( keine Umlaute ) zulassen, da sie
' >NAME-ENG   IS >NAME  \ die 1 im hchsten Bit des letzten Zeichens testen.
' "CREATE-ENG IS "CREATE
' .ID-ENG     IS .ID


CR .( Variablen mit Werten belegen )

' FORTH D4+ CURRENT !-T
' FORTH D4+ CONTEXT !-T
' CC-FORTH D4+ CC   !-T
HERE-T  20 UP @-T D+   !-T  \ 20 = Byteoffset fr DP in USER-Tabelle
#USER-T 2@       #USER !-T  \ Initiiert Zahl der USER-Variablen
-1                CAPS !-T  \ Ignoriert Kleinbuchstaben
-1             WARNING !-T  \ Warnung vor doppelter Namensbelegung an
31               WIDTH !-T  \ Maximal 31 Bytes fr das Namensfeld
VOC-LINK-T 2@ VOC-LINK !-T  \ Initiiert VOC-LINK
-1           ATTRIBUTS !-T  \ Schaltet ATTRIBUTS an
0              LMARGIN !-T  \ Wird von WORDS verwendet
70             RMARGIN !-T  \ Wird von WORDS verwendet
100              FUDGE !-T  \ Wird von MS verwendet
1               #TIMES !-T  \ Wird von MANY verwendet
3               GRMODE !-T  \ Wird von DARK verwendet ( 3 = 80*25 Farbe )
-1             ASCFILT !-T  \ Bei DUMP rechts nur ASCII-Zeichen ausgeben
0               SYS-ID !-T  \ Fr die QUIT-Meldung. Kann in Multisystemen mit
                            \ der jeweiligen Subsystem-Nummer belegt werden.
HEX
UP @-T 10 D+ @-T [ASSEMBLER] WPTR RP D2* D2* D+ [FROM] !-T   \ vorlufig
UP @-T 0C D+ @-T [ASSEMBLER] WPTR SP D2* D2* D+ [FROM] !-T   \ vorlufig
[ASSEMBLER] BPUSH WPTR BPUSHP D2* D2* D+ [FROM] !-T
[ASSEMBLER] CPUSH WPTR CPUSHP D2* D2* D+ [FROM] !-T
[ASSEMBLER] >NEXT WPTR NEXTP  D2* D2* D+ [FROM] !-T
' QUIT   [ASSEMBLER] WPTR 'QUIT   D2* D2* D+ [FROM] !-T
' BOOT   [ASSEMBLER] WPTR 'BOOT   D2* D2* D+ [FROM] !-T
[ASSEMBLER] NEST  WPTR NESTP  D2* D2* D+ [FROM] !-T

END-META

eof
