\ **********************************************************************
\ * TRANSMUL.FTH fr F-TP 1.00  [ Turbo-FORTH-83 fr Transputer T800 ] *
\ *                                                                    *
\ * Eingabe der Parameter ( Anfang, Ende und Anzahl ) fr MAKEMULT.BAT *
\ *                                                                    *
\ *     Fred Behringer  Planegger Str. 24  81241 Mnchen    5.4.96     *
\ **********************************************************************

\ Erklrungen hnlich wie in HEXBATIN.BAT

HEX

: D*I ( d n -- d*n )      \ Produkt einer doppeltgenauen Zahl und
     0. ROT 0             \ einer einfachgenauen positiven Zahl
     ?DO  2OVER D+ LOOP
     2SWAP 2DROP ;

: FEHLER CR BOLD ." Keine Hexzahl !" 2DROP ATTOFF ;

80 STRING EINGABE

2VARIABLE ANFANG
2VARIABLE ENDE
 VARIABLE ANZAHL
 VARIABLE RESTZAHL   \ Inhalt = (Anzahl)-(Counter)
2VARIABLE ORG
2VARIABLE EOS
 VARIABLE COUNTER
 VARIABLE COUNTOFF   \ Inhalt = (COUNTER)*4
2VARIABLE SUBLEN
2VARIABLE SUBORG  0FF 4 * ALLOT
2VARIABLE SUBEOS  0FF 4 * ALLOT
2VARIABLE OFS-DP

: INPUT ( -- d fl )  \ fl=TRUE: Fehler
     EINGABE INPUT$
     " . " EINGABE APPEND$ EINGABE UPPER
     EINGABE DROP 1- NUMBER? NOT ;

: PARAMETER
     ANZAHL @ 0
     DO ANFANG 2@ SUBLEN 2@ I D*I D+ 2DUP
        100.      D+ SUBORG I 1+ 4 * + 2!
        SUBLEN 2@ D+ SUBEOS I 1+ 4 * + 2!
     LOOP ;

: MAIN
     BEGIN
       CR ." Hexzahl fr den Anfang des Gesamtsystems eingeben: "
       INPUT
       IF FEHLER FALSE
       ELSE
         -4. 2AND ANFANG 2!
         CR ." Hexzahl fr das   Ende des Gesamtsystems eingeben: "
         INPUT
         IF FEHLER FALSE
         ELSE
           -4. 2AND ENDE   2!
           CR ." Hexzahl fr die Anzahl von   Subsystemen eingeben: "
           INPUT
           IF FEHLER FALSE
           ELSE
             DROP ANZAHL !
             ANFANG 2@ ENDE 2@ D>
             IF CR BOLD ." Anfang muss kleiner als Ende sein ! "
                ATTOFF FALSE
             ELSE
               ANZAHL @ 1 0FF BETWEEN NOT
               IF CR BOLD ." Anzahl muss > 0 und < 100 h sein ! "
                          ." Notfalls TRANSMUL.FTH ndern."
                  ATTOFF FALSE
               ELSE      TRUE
               THEN
             THEN
           THEN
         THEN
       THEN
       DUP 0= IF CR CR ." Wiederholung:" THEN
     UNTIL
     CR CR ." Achtung: Wurden diese Zahlen ungeeignet gewhlt, sodass zu "
           ." wenig RAM bereit-"
     CR    ." steht  oder der Platz fr die einzelnen Teilsysteme nicht aus"
           ." reicht,  so er-"
     CR    ." scheint irgendwann whrend der Metacompilation die Meldung "
           ." 'Stackberlauf' !" CR
     ANZAHL @ RESTZAHL !
     ENDE 2@ ANFANG 2@ D- ANZAHL @ MU/MOD -4. 2AND SUBLEN 2! DROP
     ANFANG 2@ SUBLEN 2@ ANZAHL @ D*I D+ ENDE 2!      CR
     ." Zur Metacompilation verwendet werden jetzt: " CR
     ." Anfang des Gesamtsystems: " ANFANG 2@ UD.     CR
     ." Ende   des Gesamtsystems: " ENDE   2@ UD.     CR
     ." Lnge  der    Subsysteme: " SUBLEN 2@ UD.     CR
     PARAMETER 0 COUNTER ! ;

: UPDATE ( -- )
     RESTZAHL 1-!
     COUNTER  1+!   COUNTER @ 4 * COUNTOFF !
     SUBORG COUNTOFF @ + 2@ ORG 2!
     SUBEOS COUNTOFF @ + 2@ EOS 2! ;

: ANZAHL!  ( -- )               \ Wird von ADDMULTI.FTH abgerufen
     ANZAHL  @ 40 0FE L! ;

: SUBWPTR! ( -- )               \ Subsystem-Workspace-Pointer nach 0040:00FC
     40 0FA L@  4* S>D          \ Subsystem-Nummer aus 0040:00FA holen
     SUBORG D+ 2@ 100. D-       \ Sub-Wptr aus Variable SUBORG holen
     40 0FC L!  40 0FE L! ;     \ 2-Byte-weise nach 0040:00FC legen
