\ NEWLEARN.FTH

\ *******************************************************
\ *                                                     *
\ *  F-TP 1.00  [ Turbo-FORTH-83 fr Transputer T800 ]  *
\ *                                                     *
\ *       Utility - Besseres LEARN fr Hostsystem       *
\ *                                                     *
\ *  Fred Behringer, Planegger Str. 24,  81241 Mnchen  *
\ *                        21.1.1996                    *
\ *                                                     *
\ *******************************************************


\ Ich habe das Wort LEARN fr das Transputer-Forth-System
\ so ausgebaut, dass es die Gesamtzahl  der Worte des be-
\ treffenden Vokabulars,  die Zahl der nicht dokumentier-
\ ten und die Zahl der dokumentierten Worte am Bildschirm
\ ausgibt  und  auerdem  die  nicht dokumentierten Worte
\ auflistet.
\ Der vorliegende Zusatz wirkt auf das Hostsystem so ein,
\ dass auch dort die genannte Statistik gefhrt wird.
\ Einlesen  vom  Hostsystem  aus  ( also  vom Transputer-
\ Forth-System aus  erst  per ESC  ins Hostsystem gehen )
\ per INCLUDE NEWLEARN.FTH .  Das bliche Wort LEARN  des
\ Hostsystems wird dann  per  ' (LEARN) IS LEARN  ( siehe
\ unten ) zum neuen (LEARN) geschaltet.


CR .( Ein erweiterbares In-Line-Dokumentationssystem )
VARIABLE #WORDS   \ Anzahl der Worte im zuletzt dokumentierten Vokabular
VARIABLE #DOC     \ Anzahl dokumentierter Worte in besagtem Vokabular
VARIABLE #UNDOC   \ Anzahl undokumentierter Worte
VARIABLE #MULTI   \ Anzahl mehrfach definierter Worte
: VIEWSOFF ( -- ) \ lscht alle View-Felder ( vfa's ) des Kontext-Vokabulars
          #WORDS OFF                           \ Wortzhler zurcksetzen
          CONTEXT @ #THREADS
          0 DO DUP I 2* +
               BEGIN @ ?DUP WHILE
                     DUP 2- ( lfa > vfa ) OFF  \ vfa lschen
                     #WORDS 1+!                \ Wortzhler weitersetzen
               REPEAT LOOP DROP ;
: UNDOCUMENTED ( -- ) \ Bildschirmausgabe der nicht dokumentierten Worte
          #UNDOC OFF  #MULTI OFF               \ Zurcksetzen
          CONTEXT @ #THREADS
          0 DO DUP I 2* +
               BEGIN @ ?DUP WHILE
                     DUP 2- ( lfa > vfa ) @ 0=
                     IF                        \ Wenn vfa = 0,
                       DUP L>NAME HERE OVER    \ Namensfeld nach
                       C@ 31 AND 1+ CMOVE      \ HERE verschieben.
                       HERE C@ 31 AND HERE C!  \ Countbyte normalisieren.
                       HERE HERE C@ + DUP C@   \ Endbyte holen
                       127 AND SWAP C!         \ und normalisieren.
                       HERE HERE               \ liegt jetzt der Name.
                       CONTEXT @ HASH @        \ Jetzt Suche
                       (FIND)                  \ im Suchvokabular.
                       IF >LINK OVER <>        \ Wenn gefunden, dann:
                         IF ." * " #MULTI 1+!  \ wenn ungleich, dann Stern
                         THEN                  \ und #MULTI weiterrcken.
                       ELSE DROP               \ Wenn nicht gefunden, dann weg.
                       THEN
                       DUP L>NAME .ID SPACE    \ Schlielich Namen ausgeben
                       #UNDOC 1+!              \ und #UNDOC weiterrcken.
                     THEN
               REPEAT
            LOOP DROP ;
: CONTINUES? ( -- fl ) \ Test, ob die nchste Zeile Leerzeile ist.
  BUFFER COUNT -TRAILING NIP 0= EOF? @ OR NOT ;
: (LEARN)   ( -- )     \ View-Felder des CONTEXT-Vokabulars indizieren
       CONTEXT @ [ CONTEXT @ HIDDEN ] VOCFILE [ CONTEXT ! ]
       HANDLE @  >R >IN @ >R  HANDLE !
       VIEWSOFF                      \ Alte Referenzen lschen
       #DOC OFF                      \ Wortzhler zurcksetzen
       BEGIN 0 0 HANDLE @ 1
             ECHO @ 0=
             IF ASCII . EMIT THEN    \ Zur Wartezeitbelebung
             (SEEK) ?DOS-ERR DROP    \ Dateizeiger-Position
             GETLINE >IN OFF
             BL WORD ?UPPERCASE DUP
             CONTEXT @ HASH @ (FIND) \ Suche in nur einem Vokabular
             IF   DUP >VIEW @ 0=
                  IF >VIEW !         \ Zeigerposition in vfa eintragen
                     #DOC 1+!        \ Wortzhler weitersetzen
                  ELSE 2DROP         \ Doppelzhlung vermeiden
                  THEN
                  BEGIN CONTINUES?   \ Wenn nchste Zeile nicht leer,
                  WHILE GETLINE      \ dann holen;
                  REPEAT             \ bis Anfang neue Erklrung
             ELSE 2DROP              \ Zeigerposition und cfa berflssig
             THEN
             EOF? @
       UNTIL
       CLOSE R> >IN ! R> HANDLE !
       BASE @ DECIMAL                                                   CR
       ." Undokumentiert geblieben sind:" CR  UNDOCUMENTED              CR
       ." Anzahl   der Worte insgesamt  im Vokabular "
          CONTEXT @ BODY> >NAME DUP .ID ." : " #WORDS ?                 CR
       ." Anzahl   dokumentierter Worte im Vokabular "
                                DUP .ID ." : " #DOC ?                   CR
       ." Anzahl undokumentierter Worte im Vokabular "
                                    .ID ." : " #UNDOC ?                 CR
       ." Anzahl berzhliger bei mehrfach definierten Worten : "
                                               #MULTI ?                 CR
       ." Diesen geht in der obigen Aufzhlung jeweils ein  *  voraus." CR
       BASE ! ;

' (LEARN) IS LEARN
